#include "./BSP/IAP/iap.h"

//------------------------------------------------------------

#define IAP_TPS_SET     (MAIN_Fosc / 1000000)

//------------------------------------------------------------

// ر IAP 
void IapIdle()
{
    IAP_CONTR = 0; // ر IAP 
    IAP_CMD = 0;   // Ĵ
    IAP_TRIG = 0;  // Ĵ
    IAP_ADDRE = 0x00;
    IAP_ADDRH = 0x00;
    IAP_ADDRL = 0x00;
}

//  IAP 
char IapRead(unsigned long addr)
{
    char dat;
    IAP_CONTR = 0x80;       // ʹ IAP
    IAP_TPS = IAP_TPS_SET;  // õȴ 12MHz
    IAP_CMD = 1;            //  IAP 
    IAP_ADDRL = addr;       //  IAP ͵ַ
    IAP_ADDRH = addr >> 8;  //  IAP ߵַ
    IAP_ADDRE = addr >> 16; //  IAP ߵַ
    IAP_TRIG = 0x5a;        // д(0x5a)
    IAP_TRIG = 0xa5;        // д(0xa5)
    _nop_();
    _nop_();
    _nop_();
    _nop_();
    dat = IAP_DATA; //  IAP 
    IapIdle();      // ر IAP 
    return dat;
}

//  IAP д
void IapProgram(unsigned long addr, char dat)
{
    IAP_CONTR = 0x80;       // ʹ IAP
    IAP_TPS = IAP_TPS_SET;  // õȴ 12MHz
    IAP_CMD = 2;            //  IAP д
    IAP_ADDRL = addr;       //  IAP ͵ַ
    IAP_ADDRH = addr >> 8;  //  IAP ߵַ
    IAP_ADDRE = addr >> 16; //  IAP ߵַ
    IAP_DATA = dat;         // д IAP 
    IAP_TRIG = 0x5a;        // д(0x5a)
    IAP_TRIG = 0xa5;        // д(0xa5)
    _nop_();
    _nop_();
    _nop_();
    _nop_();
    IapIdle(); // ر IAP 
}

//  IAP 
void IapErase(unsigned long addr)
{
    IAP_CONTR = 0x80;       // ʹ IAP
    IAP_TPS = IAP_TPS_SET;  // õȴ 12MHz
    IAP_CMD = 3;            //  IAP 
    IAP_ADDRL = addr;       //  IAP ͵ַ
    IAP_ADDRH = addr >> 8;  //  IAP ߵַ
    IAP_ADDRE = addr >> 16; //  IAP ߵַ
    IAP_TRIG = 0x5a;        // д(0x5a)
    IAP_TRIG = 0xa5;        // д(0xa5)
    _nop_();
    _nop_();
    _nop_();
    _nop_();   //
    IapIdle(); // ر IAP 
}

/**
 * @name Iap_Read
 * @brief IapNֽ
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-12-21
 * @author ߣϫ
 * @note עͣ
 *          
 */
void Iap_Read(uint32_t addr, uint8_t *pbuf, uint16_t number)
{
    while (number--)
    {
        *pbuf++ = IapRead(addr++);
    }
}

/**
 * @name Iap_Write
 * @brief IapдNֽ
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-12-21
 * @author ߣ
 * @note עͣ
 *          дǰҪƬ512ֽڽвдݣÿƬֻһ
 */
void Iap_Write(uint32_t addr, uint8_t *pbuf, uint16_t number)
{
    IapErase(addr);
    while (number--)
    {
        IapProgram(addr, *pbuf);
        addr++;
        pbuf++;
    }
}