#include "./BSP/IIC/iic.h"


//------------------------------------------------------------

uint8_t ack = 0;



//------------------------------------------------------------

void IIC_Set_GPIO(void)
{
    // P50(IIC_SCL)P51(IIC_SDA)Ϊ׼˫ڣ
    P5M0 &= ~0x03;
    P5M1 &= ~0x03; 
    P5PU |= 0x03; 
    P5SR &= ~0x03; 
}

void IIC_Init(void)
{
    IIC_Set_GPIO();
    #if IIC_Driver == SOFTWARE
    IIC_SCL = 1;
    IIC_SDA = 1;
    #elif IIC_Driver == HARDWARE
    I2C_S1 =1;      // I2Cܽѡ00:P2.4,P2.3; 01:P1.5,P1.4; 11:P3.2,P3.3
    I2C_S0 =1;      
    I2CCFG = 0xc2;  // ʹI2CģʽMSSPEED[5:0]
    I2CPSCR = 0x00; // MSSPEED[13:6]
    I2CMSST = 0x00;
    #endif
}

void IIC_Wait(void)
{
    #if IIC_Driver == SOFTWARE
    Delay2us();
    #elif IIC_Driver == HARDWARE
    while( !(I2CMSST & 0X40) );
    I2CMSST &= ~(0x40);
    #endif
}

void IIC_Start(void)            //IIC
{
    #if IIC_Driver == SOFTWARE
    IIC_SCL = 1;
    IIC_SDA = 1;
    IIC_Wait();
    IIC_SDA = 0;
    IIC_Wait();
    IIC_SCL = 0;
    IIC_Wait();
    #elif IIC_Driver == HARDWARE
    I2CMSCR = 0X01;             //ʼ
    IIC_Wait();
    #endif
}

void IIC_Stop(void)             //IIC
{
    #if IIC_Driver == SOFTWARE
    IIC_SCL = 0;
    IIC_SDA = 0;
    IIC_Wait();
    IIC_SCL = 1;
    IIC_Wait();
    IIC_SDA = 1; 
    IIC_Wait();
    #elif IIC_Driver == HARDWARE
    I2CMSCR = 0X06;             //
    IIC_Wait();
    #endif
}

void IIC_SendACK(void)          //ACK
{
    #if IIC_Driver == SOFTWARE
    IIC_SDA = 0;
    IIC_Wait();
    IIC_SCL = 1;
    IIC_Wait();
    IIC_SCL = 0;
    IIC_Wait();
    #elif IIC_Driver == HARDWARE
    I2CMSST = 0X00;             //׼ACK
    I2CMSCR = 0X05;             //ACK
    IIC_Wait();
    #endif
}

void IIC_SendNoACK(void)        //NOACK
{
    #if IIC_Driver == SOFTWARE
    IIC_SDA = 1;
    IIC_Wait();
    IIC_SCL = 1;
    IIC_Wait();
    IIC_SCL = 0;
    IIC_Wait();
    #elif IIC_Driver == HARDWARE
    I2CMSST = 0X01;             //׼NOACK
    I2CMSCR = 0X05;             //NOACK
    IIC_Wait();
    #endif
}

void IIC_WaitACK(void)          //ȴӻACK
{
    #if IIC_Driver == SOFTWARE
    IIC_SDA = 1;
    IIC_Wait();
    IIC_SCL = 1;
    IIC_Wait();
    ack = IIC_SDA;
    IIC_Wait();
    IIC_SCL = 0;
    IIC_Wait();
    #elif IIC_Driver == HARDWARE
    I2CMSCR = 0X03;             //ACK
    IIC_Wait();
    #endif
}

void IIC_SendByte(uint8_t dat)       //һֽ
{
    #if IIC_Driver == SOFTWARE
    uint8_t i = 8;
    do
    {
        if (dat & 0x80)
            IIC_SDA = 1;
        else
            IIC_SDA = 0;
        IIC_Wait();
        dat <<= 1;
        IIC_SCL = 1;
        IIC_Wait();
        IIC_SCL = 0;
        IIC_Wait();
    } while (--i);
    #elif IIC_Driver == HARDWARE
    I2CTXD = dat;               //͵дĴ
    I2CMSCR = 0X02;             //ָ
    IIC_Wait();
    #endif
}

/**
 * @name IIC_ReadByte
 * @brief IICȡһֽ
 * @param 
 * @return յ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
uint8_t IIC_ReadByte(void)           //ȡһֽ
{
    #if IIC_Driver == SOFTWARE
    uint8_t i = 8, dat = 0;
    IIC_SDA = 1;
    IIC_Wait();
    do
    {
        IIC_SCL = 1;
        IIC_Wait();
        dat <<= 1;
        if (IIC_SDA)
            dat |= 1;
        IIC_SCL = 0;
        IIC_Wait();
    } while (--i);

    return dat;
    #elif IIC_Driver == HARDWARE
    I2CMSCR = 0X04;             //ָ
    IIC_Wait();
    return I2CRXD;
    #endif
}

/**
 * @name IIC_Write_NByte
 * @brief IICдļֽ
 * @param slaveѡһӻĵַ
 * @param addrݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣ
 * @note עͣ
 */
void IIC_Write_NByte(uint16_t slave, uint8_t addr, uint8_t *p, uint8_t number) // IICдļֽ
{
    #if IIC_Driver == SOFTWARE
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    if (!ack)
    {
        IIC_SendByte(addr);
        IIC_WaitACK();
        if (!ack)
        {
            do
            {
                IIC_SendByte(*p);
                p++;
                IIC_WaitACK();
                if (ack)
                    break;
            } while (--number);
        }
    }
    IIC_Stop();
    #elif IIC_Driver == HARDWARE
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    
    IIC_SendByte(addr);
    IIC_WaitACK();

    do
    {
        IIC_SendByte(*p);
        p++;
        IIC_WaitACK();
    } while (--number);
    
    IIC_Stop();
    #endif
}


/**
 * @name IIC_Read_NByte
 * @brief IICȡļֽ
 * @param slaveѡһӻĵַ
 * @param addrҪݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣϫ
 * @note עͣͿʼ->ַд->ݵַ->Ϳʼ->ַ->
 */
void IIC_Read_NByte(uint16_t slave, uint8_t addr, uint8_t *p, uint8_t number) // IICȡļֽ
{
    #if IIC_Driver == SOFTWARE
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    if (!ack)
    {
        IIC_SendByte(addr);
        IIC_WaitACK();
        if (!ack)
        {
            IIC_Start();
            IIC_SendByte((u8)(slave + 0x01));
            IIC_WaitACK();
            if (!ack)
            {
                do
                {
                    *p = IIC_ReadByte();
                    p++;
                    if(number != 1)
                        IIC_SendACK();
                } while (--number);
                IIC_SendNoACK();
            }
            
        }
    }
    IIC_Stop();
    #elif IIC_Driver == HARDWARE
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();

    IIC_SendByte(addr);
    IIC_WaitACK();

    IIC_Start();
    IIC_SendByte((u8)(slave + 0x01));
    IIC_WaitACK();

    do
    {
        *p = IIC_ReadByte();
        p++;
        if(number != 1)
            IIC_SendACK();
    } while (--number);
    IIC_SendNoACK();
    IIC_Stop();
    #endif
    
}