#include "./BSP/LCM/lcm.h"


//------------------------------------------------------------





//------------------------------------------------------------

void LCM_GPIO_Set(void)
{
    //P2(LCD_DataPortH) ó׼˫ڣڲ
    P2M0 = 0x00;
    P2M1 = 0x00;
    P2PU = 0xff; 
    P2SR = 0x00; 
	
	#if TFT_MODE == MODE_8bit
	#elif TFT_MODE == MODE_16bit
    // P0(LCD_DataPortL) ó׼˫ڣڲ
    P0M0 = 0x00;
    P0M1 = 0x00;
    P0PU = 0xff; 
    P0SR = 0x00; 
	#endif

    // P3.7(LCM_RD),P3.6(LCM_WR) óڲ
    P3M0 |= 0xc0;
    P3M1 &= ~0xc0;
    P3PU |= 0xc0; 
    P3SR &= ~0xc0; 


    // P4.5(LCM_RS) óڲ
    P4M0 |= 0x20;
    P4M1 &= ~0x20;
    P4PU |= 0x20;
    P4SR &= ~0x20;
}

void LCM_Init(void)
{
    LCM_GPIO_Set();

    #if LCM_Driver == SOFTWARE
    #elif LCM_Driver == HARDWARE
    LCMIFCFG = (LCMIFCFG & ~0x80) | (0 << 7);   // [7] ж 1: 0:ֹ
    LCMIFCFG = (LCMIFCFG & ~0x30) | (0 << 4);   // [5:4] жȼ 0-3()
    #if TFT_MODE == MODE_8bit
    LCMIFCFG = (LCMIFCFG & ~0x0c) | (0 << 2);   // [3:2] ѡ 0:P2
	#elif TFT_MODE == MODE_16bit
    LCMIFCFG = (LCMIFCFG & ~0x0c) | (0 << 2);   // [3:2] ѡ 0:H-P2 L-P0
    #endif
    LCMIFCFG = (LCMIFCFG & ~0x02) | (TFT_MODE << 1);    // [1] D16_D8 0:8bit 1:16bit
    LCMIFCFG = (LCMIFCFG & ~0x01) | (LCM_MODE << 0);    // [0] M68_I80 0:i8080 1:M6800

    LCMIFCFG2 = (LCMIFCFG2 & ~0x60) | (1 << 5);    // [6:5] ѡ 1:P45(RS) P37(RD) P36(WR)
    LCMIFCFG2 = (LCMIFCFG2 & ~0x1c) | (1 << 2);    // [4:2] ʱ Setup Time=x+1
    LCMIFCFG2 = (LCMIFCFG2 & ~0x03) | (1 << 0);    // [1:0] ʱ  HOLD Time=x+1

    LCMIFSTA = 0x00;    // [0] LCMIFIFж־
    #endif
}

#if TFT_MODE == MODE_8bit

void lcm_wr_reg(uint8_t reg)
{
    #if LCM_Driver == SOFTWARE
    LCM_RS = 0;             // 
    LCM_WR = 0;             // дźţ׼
    LCM_DataPort = reg;     // 8λ
    LCM_WR = 1;             // дźţ
    #elif LCM_Driver == HARDWARE
    LCMIFDATL = reg;        // д8λ
    LCMIFCR = 0x84;         // ʹLCM,дź
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    #endif
}

void lcm_wr_dat(uint8_t dat)
{
    #if LCM_Driver == SOFTWARE
    LCM_RS = 1;             // 
    LCM_WR = 0;             // дźţ׼
    LCM_DataPort = dat;     // 8λ
    LCM_WR = 1;             // дźţ
    #elif LCM_Driver == HARDWARE
    LCMIFDATL = dat;        // д8λ
    LCMIFCR = 0x85;         // ʹLCM,дź
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    #endif
}

uint8_t lcm_rd_reg(void)
{
    volatile uint8_t reg = 0;
    #if LCM_Driver == SOFTWARE
    LCM_RS = 0;             // 
    LCM_RD = 0;             // źţ׼
    Delay1us();             // ʱ1us
    reg = LCM_DataPort;     // 8λ
    LCM_RD = 1;             // źţ
    #elif LCM_Driver == HARDWARE
    LCMIFCR = 0x86;		// ʹLCM,ź
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    reg = LCMIFDATL;    // 8λ
    #endif
    return reg;
}

uint8_t lcm_rd_dat(void)
{
    volatile uint8_t dat = 0;
    #if LCM_Driver == SOFTWARE
    LCM_RS = 1;             // 
    LCM_RD = 0;             // źţ׼
    Delay1us();             // ʱ1us
    dat = LCM_DataPort;     // 8λ
    LCM_RD = 1;             // źţ
    #elif LCM_Driver == HARDWARE
    LCMIFCR = 0x87;		// ʹLCM,ź
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    dat = LCMIFDATL;    // 8λ
    #endif
    return dat;
}

#elif TFT_MODE == MODE_16bit

void lcm_wr_reg(uint16_t reg)
{
    #if LCM_Driver == SOFTWARE
    LCM_RS = 0;             // 
    LCM_WR = 0;             // дźţ׼
    LCM_DataPortH = (reg >> 8) & 0xff;  // 8λ
    LCM_DataPortL = reg & 0xff;         // 8λ
    LCM_WR = 1;             // дźţ
    #elif LCM_Driver == HARDWARE
    LCMIFDATH = (reg >> 8) & 0xff;  // 8λ
    LCMIFDATL = reg & 0xff;         // 8λ        
    LCMIFCR = 0x84 | 0x10;         // ʹLCM,дź,Сģʽ
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    #endif
}

void lcm_wr_dat(uint16_t dat)
{
    #if LCM_Driver == SOFTWARE
    LCM_RS = 1;             // 
    LCM_WR = 0;             // дźţ׼
    LCM_DataPortH = (dat >> 8) & 0xff; // 8λ
    LCM_DataPortL = dat & 0xff;        // 8λ
    LCM_WR = 1;             // дźţ
    #elif LCM_Driver == HARDWARE
    LCMIFDATH = (dat >> 8) & 0xff;  // 8λ
    LCMIFDATL = dat & 0xff;         // 8λ
    LCMIFCR = 0x85 | 0x10;          // ʹLCM,дź,Сģʽ
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    #endif
}

uint16_t lcm_rd_reg(void)
{
    volatile uint16_t reg = 0;
    #if LCM_Driver == SOFTWARE
    LCM_RS = 0;             // 
    LCM_RD = 0;             // źţ׼
    Delay1us();             // ʱ1us
    reg = (LCM_DataPortH << 8) | LCM_DataPortL;
    LCM_RD = 1;             // źţ
    #elif LCM_Driver == HARDWARE
    LCMIFCR = 0x86 | 0x10;		// ʹLCM,ź,Сģʽ
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    reg = (uint16_t)(LCMIFDATH << 8) | LCMIFDATL;
    #endif
    return reg;
}

uint16_t lcm_rd_dat(void)
{
    volatile uint16_t dat = 0;
    #if LCM_Driver == SOFTWARE
    LCM_RS = 1;             // 
    LCM_RD = 0;             // źţ׼
    Delay1us();             // ʱ1us
    dat = (LCM_DataPortH << 8) | LCM_DataPortL;
    LCM_RD = 1;             // źţ
    #elif LCM_Driver == HARDWARE
    LCMIFCR = 0x87 | 0x10;		// ʹLCM,ź,Сģʽ
    while(!LCMIFSTA);
    LCMIFSTA = 0x00;
    dat = (uint16_t)(LCMIFDATH << 8) | LCMIFDATL;
    #endif
    return dat;
}

#endif

void LCM_Interrupt(void) interrupt LCM_VECTOR
{
	LCMIFSTA = 0x00;
	// LCD_CS=1;
}