#include "./BSP/SPI/spi.h"
// #include "uart1.h"

//------------------------------------------------------------





//------------------------------------------------------------

void SPI_Set_GPIO(void)
{
    // P32(SPI_SCLK)P34(SPI_MOSI)Ϊ
    // P33(SPI_MISO)Ϊ
    P3M0 = (P3M0 & ~0x08) | 0x14; P3M1 = (P3M1 & ~0x14) | 0x08;

    // P32(SPI_SCLK)P33(SPI_MISO)P34(SPI_MOSI)ڲ
    P3PU |= 0x1c;
    P3SR &= ~0x1c;
}

/**
 * @name SPI_Set_Speed
 * @brief SPIٶ
 * @param xT: SCLKʱƵѡ0:4T 1:8T 2:16T 3:2T
 * @param SCLKDIV: SPIʱӷƵ 1~255
 * @version 汾v1.0
 * @date ڣ2024-12-3
 * @author ߣϫ
 * @note עͣ  = (ʱƵ[PLL(MAIN_Fosc/HSCLKDIV)] / SCLKDIV) / xT
 */
void SPI_Set_Speed(uint8_t xT, uint8_t SCLKDIV)
{
    #if SPI_Driver == HARDWARE
    SPCTL = (SPCTL & ~3) | xT;      //SPI ʱƵѡ, 0: 4T, 1: 8T,  2: 16T,  3: 2T
    SPI_CLKDIV = SCLKDIV;           // SPI_CLKDIVʱӷƵ
    #endif
}

void SPI_Init(void)
{
	SPI_Set_GPIO();
    #if SPI_Driver == SOFTWARE
    SPI_SCLK = 0;
    SPI_MOSI = 1;
    #elif SPI_Driver == HARDWARE
    // ©·+跽ʽҪSPIƵʲFlashͨ
    // SPCTL = (SPCTL & ~3) | 0;   //SPI ʱƵѡ, 0: 4T, 1: 8T,  2: 16T,  3: 2T
    // SPI_CLKDIV = 1;     // SPI_CLKDIVʱӷƵ
    SPI_Set_Speed(SPI_02T, 2);          // (40/1)/2/2=10M

    SSIG = 1; // 1:  SS Źܣʹ MSTR ȷǴӻ;
    SPEN = 1; // 1: ʹ SPI ;
    DORD = 0; // 0: ȷ/ݵĸλ MSB;
    MSTR = 1; // 1: ģʽ;
    CPOL = 1; // 1: SCLK ʱΪߵƽSCLK ǰʱΪ½أʱΪ;
    CPHA = 1; // 1:  SCLK ǰʱʱز;
	
    //00: P1.4 P1.5 P1.6 P1.7, 01: P2.4 P2.5 P2.6 P2.7, 10: P4.0 P4.1 P4.2 P4.3, 11: P3.5 P3.4 P3.3 P3.2
    SPI_S1 = 1;
    SPI_S0 = 1;

    SPI_SCLK = 0;    // set clock to low initial state
    SPI_MOSI = 1;
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
    #endif
}

/**
 * @name SPI_Write_Byte
 * @brief SPIдһֽ
 * @param mode : 1 زɼ 0 ½زɼ
 * @param dat : Ҫд
 * @return 
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣϫ
 * @note עͣģʽֻSPIЧӲSPIڳʼʱ޸
 */
void SPI_Write_Byte(uint8_t mode, uint8_t dat)
{
    uint8_t xdata i;
    #if SPI_Driver == SOFTWARE
    i = 8;
    do{
        SPI_MOSI = dat & 0x80;
        dat <<= 1;
        if (mode)
        {
            // زɼ
            SPI_SCLK = 0;
            delay_us(5);
            SPI_SCLK = 1;
        }
        else
        {
            // ½زɼ
            SPI_SCLK = 1;
            delay_us(5);
            SPI_SCLK = 0;
        }
    }while(--i);
    
    #elif SPI_Driver == HARDWARE
    i = mode;
    SPDAT = dat;
    while(SPIF == 0);
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
    #endif
}

/**
 * @name SPI_Read_Byte
 * @brief SPIȡһֽ
 * @param mode : 1 زɼ 0 ½زɼ
 * @return ȡ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣϫ
 * @note עͣ ģʽֻSPIЧӲSPIڳʼʱ޸
 */
uint8_t SPI_Read_Byte(uint8_t mode)
{
    uint8_t xdata i, dat;
    #if SPI_Driver == SOFTWARE
    i = 8;
    do{
        dat <<= 1;
        if (mode)
        {
            // زɼ
            SPI_SCLK = 0;
            delay_us(5);
            SPI_SCLK = 1;
        }
        else
        {
            // ½زɼ
            SPI_SCLK = 1;
            delay_us(5);
            SPI_SCLK = 0;
        }
        if (SPI_MISO) dat++;
    }while(--i);
    return dat;
    #elif SPI_Driver == HARDWARE
    if(mode)
        SPDAT = 0xff;
    else
        SPDAT = 0x00;
    while(SPIF == 0);
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
    return (SPDAT);
    #endif
}

/**
 * @name SPI_Read_Write_Byte
 * @brief SPIдһֽ
 * @param mode : 1 زɼ 0 ½زɼ
 * @return ȡ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣģʽֻSPIЧӲSPIڳʼʱ޸
 */
uint8_t SPI_Read_Write_Byte(uint8_t mode, uint8_t dat)
{
    uint8_t xdata i;
	#if SPI_Driver == SOFTWARE
    uint8_t rdat;
    i = 8;
    do{
        SPI_MOSI = dat & 0x80;
        dat <<= 1;
        rdat <<= 1;

        if (mode)
        {
            // زɼ
            SPI_SCLK = 0;
            delay_us(5);
            SPI_SCLK = 1;
        }
        else
        {
            // ½زɼ
            SPI_SCLK = 1;
            delay_us(5);
            SPI_SCLK = 0;
        }

        if (SPI_MISO) rdat++;
    }while(--i);
    return rdat;
	#elif SPI_Driver == HARDWARE
    i = mode;
    SPDAT = dat;
    while(SPIF == 0);
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
    return (SPDAT);
	#endif
}

/**
 * @name SPI_Write_NByte
 * @brief spiдļֽ
 * @param mode 1 زɼ 0 ½زɼ
 * @param p 
 * @param number д뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-12-3
 * @author ߣϫ
 * @note עͣ
 */
void SPI_Write_NByte(uint8_t mode, uint8_t *p, uint8_t number)
{
    do
    {
        SPI_Write_Byte(mode, *p);
        p++;
    } while (--number);
}

/**
 * @name SPI_Read_NByte
 * @brief spiȡļֽ
 * @param mode 1 زɼ 0 ½زɼ
 * @param p 
 * @param number ȡ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-12-3
 * @author ߣϫ
 * @note עͣ
 */
void SPI_Read_NByte(uint8_t mode, uint8_t *p, uint8_t number)
{
    do
    {
        *p = SPI_Read_Byte(mode);
        p++;
    } while (--number);
}

/**
 * @name SPI_Read_Write_NByte
 * @brief spiдļֽ
 * @param mode 1 زɼ 0 ½زɼ
 * @param Rxbuf  дݵ
 * @param Txbuf  ȡݵ
 * @param number ȡ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-12-3
 * @author ߣϫ
 * @note עͣģʽֻSPIЧӲSPIʼʱ޸
 *              ע⣺ϤSPI˺ô˺
 */
void SPI_Read_Write_NByte(uint8_t mode, uint8_t *Rxbuf, uint8_t *Txbuf, uint8_t number)
{
    do
    {
        *Rxbuf = SPI_Read_Write_Byte(mode, *Txbuf);
        Rxbuf++;
        Txbuf++;
    } while (--number);
}