#include "./Hardware/AT24CXX/at24cxx.h"


//------------------------------------------------------------





//------------------------------------------------------------

void AT24Cxx_Init(void)
{
    IIC_Init();
}


/**
 * @name AT24Cxx_Read_Byte
 * @brief AT24CXXַָһ
 * @param addr: ʼĵַ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 *      ݲͬ24CXXͺ, ͸λַ
    1 24C16ϵͺ, 2ֽڷ͵ַ
    2 24C16µͺ, 1ֽڵַ + ռַbit1~bit3λ ڱʾλַ, 11λַ
        24C01/02, ַʽ(8bit)Ϊ: 1  0  1  0  A2  A1  A0  R/W
        24C04,    ַʽ(8bit)Ϊ: 1  0  1  0  A2  A1  a8  R/W
        24C08,    ַʽ(8bit)Ϊ: 1  0  1  0  A2  a9  a8  R/W
        24C16,    ַʽ(8bit)Ϊ: 1  0  1  0  a10 a9  a8  R/W
        R/W      : /дλ 0,ʾд; 1,ʾ;
        A0/A1/A2 : Ӧ1,2,3(ֻ24C01/02/04/8Щ)
        a8/a9/a10: Ӧ洢еĸλַ, 11bitַԱʾ2048λ,Ѱַ24C16ڵͺ
*/
uint8_t AT24Cxx_Read_Byte(uint16_t addr)
{
    uint8_t xdata temp = 0;
    IIC_Start(); // ʼź

    if (EE_TYPE > AT24C16) // 24C16ϵͺ, 2ֽڷ͵ַ
    {
        IIC_SendByte(SLAVE_AT24Cxx);      // д, IIC涨λ0, ʾд
        IIC_WaitACK();           // ÿηһֽ,ҪȴACK
        IIC_SendByte(addr >> 8); // ͸ֽڵַ
    }
    else
    {
        IIC_SendByte(SLAVE_AT24Cxx + ((addr >> 8) << 1)); //  0XA0 + λa8/a9/a10ַ,д
    }

    IIC_WaitACK();            // ÿηһֽ,ҪȴACK
    IIC_SendByte(addr % 256); // ͵λַ
    IIC_WaitACK();            // ȴACK, ʱַ

    IIC_Start();           // ·ʼź
    IIC_SendByte(SLAVE_AT24Cxx + 1); // ģʽ, IIC涨λ1, ʾȡ
    IIC_WaitACK();         // ÿηһֽ,ҪȴACK
    temp = IIC_ReadByte(); // һֽ
    IIC_Stop();            // һֹͣ
    return temp;
}

/**
 * @name AT24Cxx_Write_Byte
 * @brief 
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void AT24Cxx_Write_Byte(uint16_t addr, uint8_t dat)
{
    IIC_Start(); // ʼź

    if (EE_TYPE > AT24C16) // 24C16ϵͺ, 2ֽڷ͵ַ
    {
        IIC_SendByte(SLAVE_AT24Cxx);      // д, IIC涨λ0, ʾд
        IIC_WaitACK();           // ÿηһֽ,ҪȴACK
        IIC_SendByte(addr >> 8); // ͸ֽڵַ
    }
    else
    {
        IIC_SendByte(SLAVE_AT24Cxx + ((addr >> 8) << 1)); //  0XA0 + λa8/a9/a10ַ,д
    }

    IIC_WaitACK();            // ÿηһֽ,ҪȴACK
    IIC_SendByte(addr % 256); // ͵λַ
    IIC_WaitACK();            // ȴACK, ʱַ

    // Ϊдݵʱ,Ҫģʽ,ﲻ·ʼź
    IIC_SendByte(dat); // 1ֽ
    IIC_WaitACK();     // ȴACK
    IIC_Stop();        // һֹͣ
    delay_ms(10);      // ע: EEPROM дȽ,ȵ10msдһֽ
}

/**
 * @name AT24Cxx_Read
 * @brief AT24CxxȡNֽ
 * @param addr    : ʼĵַ Ӧ0-EE_TYPE
 * @param pbuf    : ݻ׵ַ
 * @param number  : Ҫݵĸ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void AT24Cxx_Read(uint16_t addr, uint8_t *pbuf, uint8_t number)
{
    while (number--)
    {
        *pbuf++ = AT24Cxx_Read_Byte(addr++);
    }
}

/**
 * @name AT24Cxx_Write
 * @brief AT24CxxдNֽ
 * @param addr    : ʼдĵַ Ӧ0-EE_TYPE
 * @param pbuf    : ݻ׵ַ
 * @param number  : Ҫдݵĸ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void AT24Cxx_Write(uint16_t addr, uint8_t *pbuf, uint8_t number)
{
    while (number--)
    {
        AT24Cxx_Write_Byte(addr, *pbuf);
        addr++;
        pbuf++;
    }
}

/**
 * @brief       AT24CXXǷ
 *   @note      ԭ: ĩַд0X55, Ȼٶȡ, ȡֵΪ0X55
 *              ʾ. ,ʾʧ.
 *
 * @param       
 * @retval      
 *              0: ɹ
 *              1: ʧ
 */
/**
 * @name AT24Cxx_Check
 * @brief AT24CXXǷ
 * @return 0: ɹ 1: ʧ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 *      ĩַд0X55, Ȼٶȡ, ȡֵΪ0X55
 *      ʾ. ,ʾʧ.
 */
uint8_t AT24Cxx_Check(void)
{
    uint8_t xdata temp;
    temp = AT24Cxx_Read_Byte(EE_TYPE); // ÿοдAT24CXX

    if (temp == 0X55) // ȡ
    {
        return 0;
    }
    else // ųһγʼ
    {
        AT24Cxx_Write_Byte(EE_TYPE, 0X55); // д
        temp = AT24Cxx_Read_Byte(EE_TYPE);  // ٶȡ

        if (temp == 0X55)
            return 0;
    }

    return 1;
}