#include "./Hardware/LCD_TFT/lcd_tft.h"
//#include "uart.h"
// е lcd_init() 䲿غֲԭlcdĻش

/*  lcd_tft_init.cŸLCDICļĴʼִ,Լlcd.c,
 *  .cļֱӼ뵽,ֻlcd.cõ,ͨincludeʽ.
 *  (Ҫļٰ.cļ!!ᱨ!)
*/
#include "./Hardware/LCD_TFT/lcd_tft_init.c"


//------------------------------------------------------------

/* LCDҪ */
_lcd_dev xdata lcddev;

/* LCDĻɫͱɫ */
uint32_t xdata g_point_color = 0XF800;    /* ɫ */
uint32_t xdata g_back_color  = 0XFFFF;    /* ɫ */

//------------------------------------------------------------

uint32_t _lcd_index(uint8_t m, uint8_t n)
{
    uint32_t xdata result = 1;
    while (n--) result *= m;
    return result;
}
/* ****************************************** ָ ****************************************** */

#if TFT_MODE == MODE_8bit
void lcd_wr_reg(uint8_t reg)
{
    LCD_CS = 0;             // ѡ
    lcm_wr_reg(reg);
    LCD_CS = 1;             // ȡ
}

void lcd_wr_reg_16bit(uint16_t dat)
{
    LCD_CS = 0;             // ѡ
    lcm_wr_reg((dat >> 8) & 0xff);
    lcm_wr_reg(dat & 0xff);
    LCD_CS = 1;             // ȡ
}

void lcd_wr_dat(uint8_t dat)
{
    LCD_CS = 0;             // ѡ
    lcm_wr_dat(dat);
    LCD_CS = 1;             // ȡ
}

void lcd_wr_dat_16bit(uint16_t dat)
{
    LCD_CS = 0;             // ѡ
    lcm_wr_dat((dat >> 8) & 0xff);
    lcm_wr_dat(dat & 0xff);
    LCD_CS = 1;             // ȡ
}

void lcd_write_reg(uint8_t reg, uint8_t dat)
{
    lcd_wr_reg(reg);
    lcd_wr_dat(dat);
}

void lcd_write_reg_16bit(uint16_t reg, uint16_t dat)
{
    lcd_wr_reg_16bit(reg);
    lcd_wr_dat_16bit(dat);
}

uint8_t lcd_rd_dat(void)
{
    volatile uint8_t dat = 0;
    LCD_CS = 0;             // ѡ
    dat = lcm_rd_dat();
    LCD_CS = 1;             // ȡ
    return dat;
}

uint16_t lcd_rd_dat_16bit(void)
{
    volatile uint16_t dat = 0;
    LCD_CS = 0;             // ѡ
    dat = lcm_rd_dat();
    dat = (dat << 8) | lcm_rd_dat();
    LCD_CS = 1;             // ȡ
    return dat;
}

#elif TFT_MODE == MODE_16bit
void lcd_wr_reg(uint16_t reg)
{
    LCD_CS = 0;             // ѡ
    lcm_wr_reg(reg);
    LCD_CS = 1;             // ȡ
}


void lcd_wr_dat(uint16_t dat)
{
    LCD_CS = 0;             // ѡ
    lcm_wr_dat(dat);
    LCD_CS = 1;             // ȡ
}


void lcd_write_reg(uint16_t reg, uint16_t dat)
{
    lcd_wr_reg(reg);
    lcd_wr_dat(dat);
}

uint16_t lcd_rd_dat(void)
{
    volatile uint16_t dat = 0;
    LCD_CS = 0;             // ѡ
    dat = lcm_rd_dat();
    LCD_CS = 1;             // ȡ
    return dat;
}
#endif

/* ****************************************** ָ ****************************************** */

/**
* @name lcd_write_ram_prepare
* @brief ׼дGRAM
* @version 汾v1.0
* @date ڣ2024
* @author ߣ
* @note עͣ
*/
void lcd_write_gram_prepare(void)
{
    lcd_wr_reg(lcddev.wramcmd);
}

void lcd_display_on(void)
{
    if (lcddev.id == 0X5510)
    #if TFT_MODE == MODE_8bit
        lcd_wr_reg_16bit(0X2900);
    #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(0X2900);
    #endif
    else
    // 9341/5310/1963/7789/7796/9806 ȷͿʾָ
    lcd_wr_reg(0x29);
}

void lcd_display_off(void)
{
    if (lcddev.id == 0X5510)
    #if TFT_MODE == MODE_8bit
        lcd_wr_reg_16bit(0X2800);
    #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(0X2800);
    #endif
    else
    // 9341/5310/1963/7789/7796/9806 ȷ͹رʾָ
        lcd_wr_reg(0x28);

}

/**
* @name lcd_set_cursor
* @brief ùλ(RGBЧ)
* @param x,y: 
* @version 汾v1.0
* @date ڣ2024
* @author ߣ
* @note עͣ
*/
void lcd_set_cursor(uint16_t x, uint16_t y)
{
        #if TFT_MODE == MODE_8bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat((uint8_t)(x >> 8));
        lcd_wr_dat((uint8_t)(x & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat((uint8_t)(y >> 8));
        lcd_wr_dat((uint8_t)(y & 0XFF));
        #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat((uint16_t)(x >> 8));
        lcd_wr_dat((uint16_t)(x & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat((uint16_t)(y >> 8));
        lcd_wr_dat((uint16_t)(y & 0XFF));
        #endif
}

/**
 * @brief       LCDԶɨ跽(RGBЧ)
 *   @note
 *              9341/5310/5510/1963/7789/7796/9806ICѾʵʲ
 *              ע:ܻܵ˺õӰ(9341),
 *              ,һΪL2R_U2D,Ϊɨ跽ʽ,ܵʾ.
 *
 * @param       dir:0~7,8(嶨lcd.h)
 * @retval      
 */
void lcd_scan_dir(uint8_t dir)
{
    uint8_t xdata regval = 0;
    uint8_t xdata dirreg = 0;
    uint8_t xdata temp;

    // ʱ1963ıɨ跽, ICıɨ跽ʱ1963ı䷽, ICıɨ跽
    if ((lcddev.dir == 1 && lcddev.id != 0X1963) || (lcddev.dir == 0 && lcddev.id == 0X1963))
    {
        switch (dir)   // ת
        {
            case 0:
                dir = 6;
                break;

            case 1:
                dir = 7;
                break;

            case 2:
                dir = 4;
                break;

            case 3:
                dir = 5;
                break;

            case 4:
                dir = 1;
                break;

            case 5:
                dir = 0;
                break;

            case 6:
                dir = 3;
                break;

            case 7:
                dir = 2;
                break;
        }
    }

    // ɨ跽ʽ  0X36 Ĵ bit 5,6,7 λֵ
    switch (dir)
    {
        case L2R_U2D:   // ,ϵ
            regval |= (0 << 7) | (0 << 6) | (0 << 5);
            break;

        case L2R_D2U:   // ,µ
            regval |= (1 << 7) | (0 << 6) | (0 << 5);
            break;

        case R2L_U2D:   // ҵ,ϵ
            regval |= (0 << 7) | (1 << 6) | (0 << 5);
            break;

        case R2L_D2U:   // ҵ,µ
            regval |= (1 << 7) | (1 << 6) | (0 << 5);
            break;

        case U2D_L2R:   // ϵ,
            regval |= (0 << 7) | (0 << 6) | (1 << 5);
            break;

        case U2D_R2L:   // ϵ,ҵ
            regval |= (0 << 7) | (1 << 6) | (1 << 5);
            break;

        case D2U_L2R:   // µ,
            regval |= (1 << 7) | (0 << 6) | (1 << 5);
            break;

        case D2U_R2L:   // µ,ҵ
            regval |= (1 << 7) | (1 << 6) | (1 << 5);
            break;
    }

    dirreg = 0X36;  // Ծ󲿷IC, 0X36Ĵ

    // 9341 & 7789 & 7796 ҪBGRλ
    if (lcddev.id == 0X9341 || lcddev.id == 0X7789 || lcddev.id == 0x7796)
    {
        regval |= 0X08;
    }

    lcd_write_reg(dirreg, regval);

    
        #if TFT_MODE == MODE_8bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat(0);
        lcd_wr_dat(0);
        lcd_wr_dat((uint8_t)((lcddev.width - 1) >> 8));
        lcd_wr_dat((uint8_t)((lcddev.width - 1) & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat(0);
        lcd_wr_dat(0);
        lcd_wr_dat((uint8_t)((lcddev.height - 1) >> 8));
        lcd_wr_dat((uint8_t)((lcddev.height - 1) & 0XFF));
        #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat(0);
        lcd_wr_dat(0);
        lcd_wr_dat((uint16_t)((lcddev.width - 1) >> 8));
        lcd_wr_dat((uint16_t)((lcddev.width - 1) & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat(0);
        lcd_wr_dat(0);
        lcd_wr_dat((uint16_t)((lcddev.height - 1) >> 8));
        lcd_wr_dat((uint16_t)((lcddev.height - 1) & 0XFF));
        #endif

}

/**
 * @brief       LCDʾ
 * @param       dir:0,; 1,
 * @retval      
 */
void lcd_display_dir(uint8_t dir)
{
    lcddev.dir = dir;   // /

    if (dir == 0)       // 
    {
        lcddev.width = 240;
        lcddev.height = 320;

        
        // else   // IC, : 9341 / 5310 / 7789 / 7796 / 9806 IC
        // {
            lcddev.wramcmd = 0X2C;
            lcddev.setxcmd = 0X2A;
            lcddev.setycmd = 0X2B;
        // }

        
    }
    else                // 
    {
        lcddev.width = 320;         // ĬϿ
        lcddev.height = 240;        // Ĭϸ߶

        
        // else   // IC, : 9341 / 5310 / 7789 / 7796 IC
        // {
            lcddev.wramcmd = 0X2C;
            lcddev.setxcmd = 0X2A;
            lcddev.setycmd = 0X2B;
        // }

    }

    lcd_scan_dir(DFT_SCAN_DIR);     // Ĭɨ跽
}

/**
 * @brief       ô(RGBЧ),Զû굽Ͻ(sx,sy).
 * @param       sx,sy:ʼ(Ͻ)
 * @param       width,height:ڿȺ͸߶,0!!
 *   @note      С:width*height.
 *
 * @retval      
 */
void lcd_set_window(uint16_t sx, uint16_t sy, uint16_t width, uint16_t height)
{
    uint16_t xdata twidth, theight;
    twidth = sx + width - 1;
    theight = sy + height - 1;

    if (lcddev.id == 0X1963 && lcddev.dir != 1)    /* 1963⴦ */
    {
        sx = lcddev.width - width - sx;
        height = sy + height - 1;
        #if TFT_MODE == MODE_8bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat((uint8_t)(sx >> 8));
        lcd_wr_dat((uint8_t)(sx & 0XFF));
        lcd_wr_dat((uint8_t)((sx + width - 1) >> 8));
        lcd_wr_dat((uint8_t)((sx + width - 1) & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat((uint8_t)(sy >> 8));
        lcd_wr_dat((uint8_t)(sy & 0XFF));
        lcd_wr_dat((uint8_t)(height >> 8));
        lcd_wr_dat((uint8_t)(height & 0XFF));
        #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat((uint16_t)(sx >> 8));
        lcd_wr_dat((uint16_t)(sx & 0XFF));
        lcd_wr_dat((uint16_t)((sx + width - 1) >> 8));
        lcd_wr_dat((uint16_t)((sx + width - 1) & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat((uint16_t)(sy >> 8));
        lcd_wr_dat((uint16_t)(sy & 0XFF));
        lcd_wr_dat((uint16_t)(height >> 8));
        lcd_wr_dat((uint16_t)(height & 0XFF));
        #endif
    }
    else if (lcddev.id == 0X5510)
    {
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat(sx >> 8);
        lcd_wr_reg(lcddev.setxcmd + 1);
        lcd_wr_dat(sx & 0XFF);
        lcd_wr_reg(lcddev.setxcmd + 2);
        lcd_wr_dat(twidth >> 8);
        lcd_wr_reg(lcddev.setxcmd + 3);
        lcd_wr_dat(twidth & 0XFF);
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat(sy >> 8);
        lcd_wr_reg(lcddev.setycmd + 1);
        lcd_wr_dat(sy & 0XFF);
        lcd_wr_reg(lcddev.setycmd + 2);
        lcd_wr_dat(theight >> 8);
        lcd_wr_reg(lcddev.setycmd + 3);
        lcd_wr_dat(theight & 0XFF);
    }
    else    /* 9341/5310/7789/1963/7796/9806  ô */
    {
        #if TFT_MODE == MODE_8bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat((uint8_t)(sx >> 8));
        lcd_wr_dat((uint8_t)(sx & 0XFF));
        lcd_wr_dat((uint8_t)(twidth >> 8));
        lcd_wr_dat((uint8_t)(twidth & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat((uint8_t)(sy >> 8));
        lcd_wr_dat((uint8_t)(sy & 0XFF));
        lcd_wr_dat((uint8_t)(theight >> 8));
        lcd_wr_dat((uint8_t)(theight & 0XFF));
        #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(lcddev.setxcmd);
        lcd_wr_dat((uint16_t)(sx >> 8));
        lcd_wr_dat((uint16_t)(sx & 0XFF));
        lcd_wr_dat((uint16_t)(twidth >> 8));
        lcd_wr_dat((uint16_t)(twidth & 0XFF));
        lcd_wr_reg(lcddev.setycmd);
        lcd_wr_dat((uint16_t)(sy >> 8));
        lcd_wr_dat((uint16_t)(sy & 0XFF));
        lcd_wr_dat((uint16_t)(theight >> 8));
        lcd_wr_dat((uint16_t)(theight & 0XFF));
        #endif
    }
}

/**
 * @brief       SSD1963ú
 * @param       pwm: ȼ,0~100.ԽԽ.
 * @retval      
 */
void lcd_ssd_backlight_set(uint8_t pwm)
{
    lcd_wr_reg(0xBE);           // PWM
    lcd_wr_dat(0x05);           // 1PWMƵ
    lcd_wr_dat(pwm * 2.55);     // 2PWMռձ
    lcd_wr_dat(0x01);           // 3C
    lcd_wr_dat(0xFF);           // 4D
    lcd_wr_dat(0x00);           // 5E
    lcd_wr_dat(0x00);           // 6F
}

void LCD_Set_GPIO(void)
{
    // P1.0(LCD_CS) ڲ
    P1M0 |= 0x01;
	P1M1 &= ~0x01; 
    P1PU |= 0x01; 
    P1SR &= ~0x01; 

//    //P1.5(LCD_BL) 
//    P1M0 |= 0x20;
//    P1M1 &= ~0x20;
}

void lcd_init(void)
{
    // LCM_Init();
    LCD_Set_GPIO();
    delay_ms(50);
    LCD_RESET = 0;
    delay_ms(50);
    LCD_RESET = 1;
    delay_ms(50);

    lcddev.id = 0xA5A5;
    // 9341 IDĶȡ 
    lcd_wr_reg(0XD3);
    lcddev.id = lcd_rd_dat();  // dummy read 
    lcddev.id = lcd_rd_dat();  // 0X00 
    lcddev.id = lcd_rd_dat();  // ȡ0X93 
    lcddev.id <<= 8;
    lcddev.id |= lcd_rd_dat(); // ȡ0X41 

    

//    printf("LCD ID:%x\r\n", lcddev.id); // ӡLCD ID

    if (lcddev.id == 0X7789)
    {
        lcd_ex_st7789_reginit();    // ִST7789ʼ
    }
    else if (lcddev.id == 0X9341)
    {
        lcd_ex_ili9341_reginit();   // ִILI9341ʼ
    }
    

    lcd_display_dir(LCD_DIRECTION); // ĬΪ0 
    // LCD_BL = 1;                     // 
    lcd_clear(BLACK);
}

/* ****************************************** ָ ****************************************** */
/**
 * @brief       
 * @param       color: Ҫɫ
 * @retval      
 */
void lcd_clear(uint16_t color)
{
    uint32_t xdata index = 0;
    uint32_t xdata totalpoint = lcddev.width;
    totalpoint *= lcddev.height;    // õܵ
    lcd_set_cursor(0, 0);           // ùλ
    lcd_write_gram_prepare();        // ʼдGRAM

    for (index = 0; index < totalpoint; index++)
    {
        #if TFT_MODE == MODE_8bit
        lcd_wr_dat_16bit(color);
        #elif TFT_MODE == MODE_16bit
        lcd_wr_dat(color);
        #endif
    }
}

/**
 * @brief       
 * @param       x,y: 
 * @param       color: ɫ(32λɫ,LTDC)
 * @retval      
*/
void lcd_draw_point(uint16_t x, uint16_t y, uint16_t color)
{
    if (x >= lcddev.width )    x = lcddev.width - 1;
    if (y >= lcddev.height )    y = lcddev.height - 1;
    lcd_set_cursor(x, y);       // ùλ
    lcd_write_gram_prepare();   // ʼдGRAM
    #if TFT_MODE == MODE_8bit
    lcd_wr_dat_16bit(color);
    #elif TFT_MODE == MODE_16bit
    lcd_wr_dat(color);
    #endif
}

/**
* @name lcd_read_color
* @brief ȡһRGB565ɫ
* @return 
* @version 汾v1.0
* @date ڣ2024-10-10
* @author ߣϫ
* @note עͣ
*/
uint16_t lcd_read_point_color(uint16_t x, uint16_t y)
{
    uint16_t xdata color = 0;
    uint16_t xdata r = 0, g = 0, b = 0;
    if (x >= lcddev.width || y >= lcddev.height)    return 0xffff;  // ˷Χ,ֱӷ

    lcd_set_cursor(x, y);   // 

    if (lcddev.id == 0X5510)
        #if TFT_MODE == MODE_8bit
        lcd_wr_reg_16bit(0X2E00);
        #elif TFT_MODE == MODE_16bit
        lcd_wr_reg(0X2E00);
        #endif
    else
        lcd_wr_reg(0X2E);   // 9341/5310/1963/7789/7796/9806 ȷͶGRAMָ

    #if TFT_MODE == MODE_8bit
    r = lcd_rd_dat();   // dummy read

    if (lcddev.id == 0x1963)
    {
        color = (r << 8) | lcd_rd_dat();
        return color;   // 1963ֱӶͿ
    }

    r = lcd_rd_dat();   // 8bit: red data

    if (lcddev.id == 0x7796)    // 7796 һζȡһֵ
    {
        color = (r << 8) | lcd_rd_dat();
        return color;
    }

    // ILI9341/NT35310/NT35510/ST7789/ILI9806
    g = lcd_rd_dat();   // 8bit: green data
    b = lcd_rd_dat();   // 8bit: blue data
    color = (((r >> 3) << 11) | ((g >> 2) << 5) | (b >> 3));

    return color;

    #elif TFT_MODE == MODE_16bit
    r = lcd_rd_dat();   // dummy read

    if (lcddev.id == 0x1963)
    {
        return r;   // 1963ֱӶͿ
    }

    r = lcd_rd_dat();   // 16bit: red and green data

    if (lcddev.id == 0x7796)    // 7796 һζȡһֵ
    {
        return r;
    }

    // ILI9341/NT35310/NT35510/ST7789/ILI9806
    b = lcd_rd_dat();   // 16bit: blue data
    g = r & 0XFF;       //  9341/5310/5510/7789/9806, һζȡRGֵ,Rǰ,Gں,ռ8λ
    g <<= 8;
    r = (((r >> 11) << 11) | ((g >> 10) << 5) | (b >> 11));

    return r;
    #endif
}

/**
 * @name lcd_fill_area
 * @brief ָɫ(Խ)
 * @param x0,y0     ʼ
 * @param x1,y1     ý
 * @param color     Ҫɫ
 * @version 汾v1.0
 * @date ڣ2024-10-12
 * @author ߣϫ
 * @note עͣ
 */
void lcd_fill_area(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color)
{
    uint16_t xdata i, j;
    uint16_t xdata xlen = 0;
    xlen = x1 - x0;
    for ( i = y0; i <= y1; i++)
    {
        lcd_set_cursor(x0, i);      // ùλ
        lcd_write_gram_prepare();   // ʼдGRAM
        for ( j = 0; j <= xlen; j++)
        {
            #if TFT_MODE == MODE_8bit
            lcd_wr_dat_16bit(color);
            #elif TFT_MODE == MODE_16bit
            lcd_wr_dat(color);
            #endif
        }
    }
}

/**
 * @name lcd_draw_line
 * @brief 
 * @param x0,y0     ʼ
 * @param x1,y      ý
 * @param color     Ҫɫ
 * @version 汾v1.0
 * @date ڣ2024-10-12
 * @author ߣϫ
 * @note עͣ
 */
void lcd_draw_line(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color)
{
    uint16_t xdata t;
    int xerr = 0, yerr = 0, delta_x, delta_y, distance;
    int incx, incy, uRow, uCol;
    delta_x = x1 - x0;      // 
    delta_y = y1 - y0;
    uRow = x0;              // 
    uCol = y0;

    if(delta_x > 0)         incx = 1;   // õ
    else if (delta_x == 0)  incx = 0;   // ֱ
    else                    incx = -1, delta_x = -delta_x;

    if(delta_y > 0)         incy = 1;   // õ
    else if (delta_y == 0)  incy = 0;   // ˮƽ
    else                    incy = -1, delta_y = -delta_y;

    // ѡȡ
    if(delta_x > delta_y)   distance = delta_x;
    else                    distance = delta_y;

    for (t = 0; t <= distance + 1; t++)
    {
        lcd_draw_point(uRow, uCol, color); // 
        xerr += delta_x;
        yerr += delta_y;
        
        if(xerr > distance)
        {
            xerr -= distance;
            uRow += incx;
        }
        
        if(yerr > distance)
        {
            yerr -= distance;
            uCol += incy;
        }
    }
}

/**
 * @name lcd_draw_bline
 * @brief 
 * @param x1,y1: ʼ
 * @param x2,y2: ý
 * @param size : ϸ̶
 * @param color: Ҫɫ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */


/**
 * @name lcd_draw_rectangle
 * @brief (Խ)
 * @param x0,y0     ʼ
 * @param x1,y1     ý
 * @param fill      1:ʵ 0:
 * @param color     Ҫɫ
 * @version 汾v1.0
 * @date ڣ2024-10-12
 * @author ߣϫ
 * @note עͣ
 */
void lcd_draw_rectangle(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint8_t fill, uint16_t color)
{
    if(fill)
    {
        lcd_fill_area(x0, y0, x1, y1, color);
    }
    else
    {
        lcd_draw_line(x0, y0, x1, y0, color);
        lcd_draw_line(x1, y0, x1, y1, color);
        lcd_draw_line(x1, y1, x0, y1, color);
        lcd_draw_line(x0, y1, x0, y0, color);
    }
}

/**
 * @name lcd_draw_circle_base
 * @brief 
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-10-12
 * @author ߣ
 * @note עͣ
                    7       0

                6               1


                5               2

                    4       3
*/
void lcd_draw_circle_base(uint16_t x, uint16_t y, uint16_t Rx, uint16_t Ry, uint16_t color)
{

    lcd_draw_point(x + Rx, y + Ry, color);  // 6
    lcd_draw_point(x - Rx, y + Ry, color);  // 1
    lcd_draw_point(x + Rx, y - Ry, color);  // 5
    lcd_draw_point(x - Rx, y - Ry, color);  // 2
    lcd_draw_point(x + Ry, y + Rx, color);  // 4
    lcd_draw_point(x - Ry, y + Rx, color);  // 3
    lcd_draw_point(x + Ry, y - Rx, color);  // 0
    lcd_draw_point(x - Ry, y - Rx, color);  // 7
}

/**
 * @name lcd_draw_circle
 * @brief Բ
 * @param x,y       Բ
 * @param r         뾶
 * @param fill      1:ʵ 0:
 * @param color     Ҫɫ
 * @version 汾v1.0
 * @date ڣ2024-10-12
 * @author ߣϫ
 * @note עͣ
 */
void lcd_draw_circle(uint16_t x, uint16_t y, uint8_t r, uint8_t fill, uint16_t color)
{
    int xdata a = 0, b = r, yi;
    int xdata di = 3 - (r << 1);

    if (fill)
    {
        while (a <= b)
        {
            for ( yi = a; yi <= b; yi++)
                lcd_draw_circle_base(x, y, a, yi, color);
            
            // ʹBresenham㷨Բ 
            if (di < 0)
                di += 4 * a + 6;
            else
            {
                di += 10 + 4 * (a - b);
                b--;
            }
            a++;
        }
        
    }
    else
    {
        while (a <= b)
        {
            lcd_draw_circle_base(x, y, a, b, color);
            
            // ʹBresenham㷨Բ 
            if (di < 0)
                di += 4 * a + 6;
            else
            {
                di += 10 + 4 * (a - b);
                b--;
            }
            a++;
        }
    }
}


/* ****************************************** ָ ****************************************** */

/**
 * @name lcd_show_char
 * @brief ʾַ
 * @param x,y       ʾʼ
 * @param mode      0 ǵģʽ  1 ģʽ
 * @param ascii     
 * @param sizey     ֺţ12,16,24,32 Ĭ16
 * @param fc        ɫ
 * @param bc        ɫ
 * @param chr       Ҫʾַ
 * @version 汾v1.0
 * @date ڣ2024-10-13
 * @author ߣϫ
 * @note עͣ
 */
void lcd_show_char(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, uint8_t sizey, uint16_t fc, uint16_t bc, char chr)
{
    uint8_t xdata temp, m, t;
    uint16_t xdata y0 = y;
    uint8_t xdata sizex = sizey / 2;
    uint8_t xdata TypefaceNum;         // һַռֽڴС

    TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizex;
    chr = chr - ' ';            // õƫƺֵ

    for ( t = 0; t < TypefaceNum; t++)
    {
        temp =ascii[TypefaceNum * chr + t];
        for ( m = 0; m < 8; m++)
        {
            if (temp & (0x80 >> m))         // λǰ
                lcd_draw_point(x, y, fc);
            else if (!mode)     // ǵģʽ
                lcd_draw_point(x, y, bc);
            // ֱɨ
            y++;        // y 
            if (y >= lcddev.height)    return;      // y곬
            if ((y - y0) == sizey)   // ʾһ
            {
                y = y0;     // y
                x++;        // x 
                if (x >= lcddev.width)    return;   // x곬
                break;      // һ
            }
        }
    }
}



/**
 * @name lcd_show_chinese_24x24
 * @brief ʾһ(24x24)
 * @param x,y       
 * @param mode      0 ǵģʽ  1 ģʽ
 * @param Font      
 * @param fc        ɫ
 * @param bc        ɫ
 * @param *s        ִ
 * @version 汾v1.0
 * @date ڣ2024-10-13
 * @author ߣϫ
 * @note עͣ
 */
void lcd_show_chinese_24x24(uint16_t x, uint16_t y, uint8_t mode, FONT_GB24 *Font, uint16_t fc, uint16_t bc, char *s)
{
    uint8_t xdata i, j, k, m = 0;
    uint8_t xdata pGBK = 0;
    uint8_t xdata SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
    uint16_t xdata pIndex;
    uint16_t xdata y0 = y;
    uint16_t xdata TypefaceNum = 72; // һַռֽڴС

    for (i = 0; s[i] != '\0'; i++)        // Ҫʾĺֿ
    {
        SingleChinese[pGBK] = s[i];        // ȡִݵ
        pGBK++;                         // ƴ
        // ȡﺺֳʱȡһĺ
        if (pGBK >= TFT_CHN_CHAR_WIDTH)
        {
            pGBK = 0;
            // ģ⣬Ѱƥĺ
            // ҵһ֣Ϊַʾδģⶨ壬ֹͣѰ
            for (pIndex = 0; strcmp(Font[pIndex].txt, "") != 0; pIndex++)
            {
                // ҵƥĺ
                if (strcmp(Font[pIndex].txt, SingleChinese) == 0)
                break;    // ѭʱpIndexֵΪֵָ
            }

            // ģָ12*12ͼʽʾ
            for (k = 0; k < TypefaceNum; k++)
            {
                for (j = 0; j < 8; j++)
                {
                    if (Font[pIndex].dat[k] & (0x80 >> j))     // λǰ
                        lcd_draw_point(x, y, fc);
                    else if (!mode)     // ǵģʽ
                        lcd_draw_point(x, y, bc);
                    // ֱɨ
                    y++;                // y 
                    if (y >= lcddev.height)     return;
                    if ((y - y0) == Fsize2412)
                    {
                        y = y0;
                        x++;            // x 
                        if (x >= lcddev.width)  return;
                        break;          // һ
                    }
                }
            }
        }
        continue;    // ҵӦֿ˳ֹظȡģӰ
    }
}


/**
 * @name lcd_show_cn_en
 * @brief ʾһӢ
 * @param x,y       
 * @param mode      0 ǵģʽ  1 ģʽ
 * @param ascii     
 * @param Font      
 * @param sizey     ֺţ12,16,24,32 Ĭ16
 * @param fc        ɫ
 * @param bc        ɫ
 * @param *str      ִ
 * @version 汾v1.0
 * @date ڣ2024-10-13
 * @author ߣϫ
 * @note עͣ
 */
void lcd_show_cn_en(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, /*uint8_t *Font,*/ uint8_t sizey, uint16_t fc, uint16_t bc, char *str)
{
    uint8_t xdata pGBK = 0;
    uint8_t xdata i, k = 0;
    uint8_t xdata SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
    uint8_t xdata sizex = sizey / 2;
    uint16_t xdata px = x;
    
    for (i = 0; str[i] != '\0'; i++)
    {
        if ( (str[i] <= '~') && (str[i] >= ' ') )
        {
            lcd_show_char(px, y, mode, (uint8_t *)ascii, sizey, fc, bc, str[i]);
            px += sizex;
            // Զ
            if (px + sizex > lcddev.width)
            {
                px = 0;
                y += sizey;
                if (y > lcddev.height)
                    y = 0;
            }
        }
        else
        {
            SingleChinese[pGBK] = str[i];           // ȡִݵ
            pGBK++;                                 // ƴ

            // ȡﺺֳʱȡһĺ
            if (pGBK >= TFT_CHN_CHAR_WIDTH)
            {
                pGBK = 0;       // ƴι
            

                    lcd_show_chinese_24x24(px, y, mode, Font_GB24, fc, bc, SingleChinese);


                // Զ
                px += sizey;
                if ( px + sizey > lcddev.width)     
                {
                    px = 0;
                    y += sizey;
                    if (y > lcddev.height)
                        y = 0;
                }
            }
        }
    }
}

/**
 * @name lcd_printf
 * @brief lcd printf ӡ
 * @param x,y       
 * @param mode      0 ǵģʽ  1 ģʽ
 * @param ascii     
 * 
 * @param sizey     ֺţ12,16,24,32 Ĭ16
 * @param fc        ɫ
 * @param bc        ɫ
 * @param *format   ִ
 * @version 汾v1.0
 * @date ڣ2024-10-13
 * @author ߣϫ
 * @note עͣ
 */
void lcd_printf(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, /*uint8_t *Font,*/ uint8_t sizey, uint16_t fc, uint16_t bc, char *format, ...)
{
    char xdata String[64];               // ַ
    va_list arg;                   // ɱб͵ıarg
    va_start(arg, format);         // formatʼղбarg
    vsprintf(String, format, arg); // ʹvsprintfӡʽַͲбַ
    va_end(arg);                   // arg
    lcd_show_cn_en(x, y, mode, ascii, sizey, fc, bc, String);
}

