#ifndef __LCD_TFT_H_
#define __LCD_TFT_H_

#include <config.h>
#include "./LCD_TFT/lcd_font.h"
#include "./BSP/LCM/lcm.h"

/******************************************************************************************/
/* ȷʹLCDIC ͨرICʼ򣬽ʡڴ */
// #define LCD_ST7789
#define LCD_ILI9341
// #define LCD_NT35310
// #define LCD_ST7796
// #define LCD_NT35510
// #define LCD_ILI9806
// #define LCD_SSD1963

/******************************************************************************************/
/*
    AI8051Uʵ佨ã
    LCD_DIRECTION   1
    DFT_SCAN_DIR    L2R_U2D
*/
#define LCD_DIRECTION   0           // 0: 1:
/* ɨ跽 */
#define L2R_U2D         0           // ,ϵ 000
#define L2R_D2U         1           // ,µ 000,·ת
#define R2L_U2D         2           // ҵ,ϵ 180,·ת
#define R2L_D2U         3           // ҵ,µ 180

#define U2D_L2R         4           // ϵ, 270,ҷת
#define U2D_R2L         5           // ϵ,ҵ 270
#define D2U_L2R         6           // µ, 090
#define D2U_R2L         7           // µ,ҵ 090,ҷת

#define DFT_SCAN_DIR    L2R_U2D     // Ĭϵɨ跽 L2R_U2D

/******************************************************************************************/
/* ֺŴС */
#define Fsize1206       12
#define Fsize1608       16
#define Fsize2412       24
#define Fsize3216       32

/* ûɫ */
#define WHITE           0xFFFF      /* ɫ */
#define BLACK           0x0000      /* ɫ */
#define RED             0xF800      /* ɫ */
#define GREEN           0x07E0      /* ɫ */
#define BLUE            0x001F      /* ɫ */ 
#define MAGENTA         0XF81F      /* Ʒɫ/Ϻɫ = BLUE + RED */
#define YELLOW          0XFFE0      /* ɫ = GREEN + RED */
#define CYAN            0X07FF      /* ɫ = GREEN + BLUE */  

/* ǳɫ */
#define BROWN           0XBC40      /* ɫ */
#define BRRED           0XFC07      /* غɫ */
#define GRAY            0X8430      /* ɫ */ 
#define DARKBLUE        0X01CF      /* ɫ */
#define LIGHTBLUE       0X7D7C      /* ǳɫ */ 
#define GRAYBLUE        0X5458      /* ɫ */ 
#define LIGHTGREEN      0X841F      /* ǳɫ */  
#define LGRAY           0XC618      /* ǳɫ(PANNEL),屳ɫ */ 
#define LGRAYBLUE       0XA651      /* ǳɫ(мɫ) */ 
#define LBBLUE          0X2B12      /* ǳɫ(ѡĿķɫ) */ 

/******************************************************************************************/
/* SSD1963ò(һ㲻ø) */

/* LCDֱ */ 
#define SSD_HOR_RESOLUTION      800     /* LCDˮƽֱ */ 
#define SSD_VER_RESOLUTION      480     /* LCDֱֱ */ 

/* LCD */ 
#define SSD_HOR_PULSE_WIDTH     1       /* ˮƽ */ 
#define SSD_HOR_BACK_PORCH      46      /* ˮƽǰ */ 
#define SSD_HOR_FRONT_PORCH     210     /* ˮƽ */ 

#define SSD_VER_PULSE_WIDTH     1       /* ֱ */ 
#define SSD_VER_BACK_PORCH      23      /* ֱǰ */ 
#define SSD_VER_FRONT_PORCH     22      /* ֱǰ */ 

/* ¼Զ */ 
#define SSD_HT          (SSD_HOR_RESOLUTION + SSD_HOR_BACK_PORCH + SSD_HOR_FRONT_PORCH)
#define SSD_HPS         (SSD_HOR_BACK_PORCH)
#define SSD_VT          (SSD_VER_RESOLUTION + SSD_VER_BACK_PORCH + SSD_VER_FRONT_PORCH)
#define SSD_VPS         (SSD_VER_BACK_PORCH)

/******************************************************************************************/

//------------------------------Ŷ------------------------------

#define  LCD_CS         P10     // Ƭѡ͵ƽѡ
#define  LCD_RESET      P47     // λ͵ƽλ
// #define  LCD_BL         P15     // ⣬ߵƽ

// LCDĻɫͱɫ	   
extern u16  xdata POINT_COLOR;        // ĬϺɫ    
extern u16  xdata BACK_COLOR;         // ɫ.ĬΪɫ

//-----------------------------ṹ嶨------------------------------

/* LCDҪ lcd_display_dir()Զ */
#if TFT_MODE == MODE_8bit
typedef struct
{
    uint16_t width;     // LCD 
    uint16_t height;    // LCD ߶
    uint16_t id;        // LCD ID
    uint8_t dir;        // ƣ01
    uint8_t wramcmd;    // ʼдgramָ
    uint8_t setxcmd;    // xָ
    uint8_t setycmd;    // yָ
} _lcd_dev;
#elif TFT_MODE == MODE_16bit
typedef struct
{
    uint16_t width;     // LCD 
    uint16_t height;    // LCD ߶
    uint16_t id;        // LCD ID
    uint8_t dir;        // ƣ01
    uint16_t wramcmd;    // ʼдgramָ
    uint16_t setxcmd;    // xָ
    uint16_t setycmd;    // yָ
} _lcd_dev;
#endif

/* LCD */
extern _lcd_dev xdata lcddev; /* LCDҪ */


//------------------------------------------------------------


//------------------------------------------------------------

void LCD_Set_GPIO(void);

#if TFT_MODE == MODE_8bit
void lcd_wr_reg(uint8_t reg);
void lcd_wr_reg_16bit(uint16_t dat);
void lcd_wr_dat(uint8_t dat);
void lcd_wr_dat_16bit(uint16_t dat);
void lcd_write_reg(uint8_t reg, uint8_t dat);
void lcd_write_reg_16bit(uint16_t reg, uint16_t dat);
uint8_t lcd_rd_dat(void);
uint16_t lcd_rd_dat_16bit(void);

#elif TFT_MODE == MODE_16bit
void lcd_wr_reg(uint16_t reg);
void lcd_wr_dat(uint16_t dat);
void lcd_write_reg(uint16_t reg, uint16_t dat);
uint16_t lcd_rd_dat(void);

#endif

void lcd_display_on(void);
void lcd_display_off(void);
void lcd_set_cursor(uint16_t x, uint16_t y);
void lcd_scan_dir(uint8_t dir);
void lcd_display_dir(uint8_t dir);
void lcd_set_window(uint16_t sx, uint16_t sy, uint16_t width, uint16_t height);
void lcd_ssd_backlight_set(uint8_t pwm);
void lcd_init(void);

void lcd_clear(uint16_t color);
void lcd_draw_point(uint16_t x, uint16_t y, uint16_t color);
uint16_t lcd_read_point_color(uint16_t x, uint16_t y);
void lcd_fill_area(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color);
void lcd_draw_line(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color);
// void lcd_draw_bline(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint8_t size, uint16_t color);
void lcd_draw_rectangle(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint8_t fill, uint16_t color);
void lcd_draw_circle_base(uint16_t x, uint16_t y, uint16_t Rx, uint16_t Ry, uint16_t color);
void lcd_draw_circle(uint16_t x, uint16_t y, uint8_t r, uint8_t fill, uint16_t color);
// void lcd_draw_triangel_base(uint16_t a1, uint16_t b1, uint16_t a2, uint16_t b2, uint16_t xa, uint16_t yb, uint16_t color);
// void lcd_draw_triangel(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint8_t fill, uint16_t color);
// void lcd_draw_elliptic(uint16_t x0, uint16_t y0, uint16_t r1, uint16_t r2, uint8_t fill, uint16_t color);
// void lcd_draw_round_rectangle(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t r, uint8_t fill, uint16_t color);

void lcd_show_char(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, uint8_t sizey, uint16_t fc, uint16_t bc, char chr);
// void lcd_show_string(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, uint8_t sizey, uint16_t fc, uint16_t bc, char *chr);
// void lcd_show_num_u32(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, uint8_t sizey, uint16_t fc, uint16_t bc, uint32_t num, uint8_t len);
// void lcd_show_num_float(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, uint8_t sizey, uint16_t fc, uint16_t bc, float num, uint8_t len, uint8_t decimal);
// void lcd_show_chinese_12x12(uint16_t x, uint16_t y, uint8_t mode, FONT_GB12 *Font, uint16_t fc, uint16_t bc, char *s);
// void lcd_show_chinese_16x16(uint16_t x, uint16_t y, uint8_t mode, FONT_GB16 *Font, uint16_t fc, uint16_t bc, char *s);
void lcd_show_chinese_24x24(uint16_t x, uint16_t y, uint8_t mode, FONT_GB24 *Font, uint16_t fc, uint16_t bc, char *s);
// void lcd_show_chinese_32x32(uint16_t x, uint16_t y, uint8_t mode, FONT_GB32 *Font, uint16_t fc, uint16_t bc, char *s);
void lcd_show_cn_en(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, /*uint8_t *Font,*/ uint8_t sizey, uint16_t fc, uint16_t bc, char *str);
void lcd_printf(uint16_t x, uint16_t y, uint8_t mode, uint8_t *ascii, /*uint8_t *Font,*/ uint8_t sizey, uint16_t fc, uint16_t bc, char *format, ...);
// void lcd_show_bmp(uint16_t x, uint16_t y, uint16_t width_X, uint16_t height_Y, const uint8_t pic[]);

#endif