#include "./Hardware/TOUCH/touch.h"
#include "./Hardware/LCD_TFT/lcd_tft.h"
// #include "./Hardware/AT24CXX/at24cxx.h"
// #include "./BSP/IAP/iap.h"
#include "./Middlewares/EEPROM/eeprom.h"


//------------------------------------------------------------

_m_tp_dev xdata tp_dev =
    {
        TP_Init,    // ʼ
        tp_scan,    // ɨ败.0,Ļɨ;1,
        tp_adjust,  // У׼
        0,          // ǰx
        0,          // ǰy
        0,          // ʵ״̬(sta): b15:1/ɿ0; b14:0,ûа;1,а; b13~b10:; b9~b0:ݴµĵ(0,ʾδ,1ʾ)
        0,          // 5У׼x(xfac)
        0,          // 5У׼y(yfac)
        0,          // Xֵ(ADֵ)(xc)
        0,          // Yֵ(ADֵ)(yc)
        0,          // Ĳ,ȫߵʱҪõ:(touchtype)
                    // b0:0, (ʺΪX,ΪYTP); 1, (ʺΪY,ΪXTP)
                    // b1~6: .
                    // b7:0, ; 1, 
};

//------------------------------------------------------------

static void TP_Write_Byte(uint8_t dat)
{
    /* SPIд1λ */
    SPI_Read_Write_Byte(1, dat);
}

static uint16_t TP_Read_AD(uint8_t cmd)
{
    uint16_t xdata dat = 0;
    uint8_t xdata count = 0;
    uint8_t xdata buff[2];
    SPI_Set_Speed(SPI_08T, 5);  // 2.5M/5=500k
    

    RT_CS = 0;          // ѡдIC
    TP_Write_Byte(cmd); // 
	
	/* SPIд1λ */
    buff[0] = SPI_Read_Write_Byte(1, 0x00);
    buff[1] = SPI_Read_Write_Byte(1, 0x00);

    dat = (uint16_t)(buff[0]) << 8 | buff[1];
    RT_CS = 1;
    SPI_Set_Speed(SPI_04T, 1);  // 10M
    return (dat >> 4);
}

/* 败оƬ ݲɼ ˲ò */
// ʱ: TP_READ_TIMES > 2*TP_LOST_VAL 
#define TP_READ_TIMES   5       // ȡ
#define TP_LOST_VAL     1       // ֵ

/**
 * @name tp_read_xy0
 * @brief ȡһֵ(xy)
 * @param cmd : ָ
 *              0XD0: ȡX(@״̬,״̬YԵ.) 
 *              0X90: ȡY(@״̬,״̬XԵ.) 
 * @return ȡ(˲), ADCֵ(12bit)
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 *          ȡTP_READ_TIMES,Щ,
 *          ȻȥͺTP_LOST_VAL, ȡƽֵ
 *          ʱ: TP_READ_TIMES > 2*TP_LOST_VAL 
 */
static uint16_t tp_read_xy0(uint8_t cmd)
{
    uint16_t xdata i, j;
    uint16_t xdata buf[TP_READ_TIMES];
    uint16_t xdata sum = 0;
    uint16_t xdata temp;

    for (i = 0; i < TP_READ_TIMES; i++)   // ȶȡTP_READ_TIMES
    {
        buf[i] = TP_Read_AD(cmd);
    }

    for (i = 0; i < TP_READ_TIMES - 1; i++)   // ݽ
    {
        for (j = i + 1; j < TP_READ_TIMES; j++)
        {
            if (buf[i] > buf[j])   // 
            {
                temp = buf[i];
                buf[i] = buf[j];
                buf[j] = temp;
            }
        }
    }

    sum = 0;

    for (i = TP_LOST_VAL; i < TP_READ_TIMES - TP_LOST_VAL; i++)   // ȥ˵Ķֵ
    {
        sum += buf[i];  // ۼȥֵԺ.
    }

    temp = sum / (TP_READ_TIMES - 2 * TP_LOST_VAL); // ȡƽֵ
    return temp;
}

/**
 * @name tp_read_xy1
 * @brief ȡһx, y
 * @param x,y: ȡֵ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
static void tp_read_xy1(uint16_t *x, uint16_t *y)
{
    uint16_t xdata xval, yval;

    if (tp_dev.touchtype & 0X01)    // X,YĻ෴
    {
        xval = tp_read_xy0(0X90);   // ȡXADֵ, з任
        yval = tp_read_xy0(0XD0);   // ȡYADֵ
    }
    else                            // X,YĻͬ
    {
        xval = tp_read_xy0(0XD0);   // ȡXADֵ
        yval = tp_read_xy0(0X90);   // ȡYADֵ
    }

    *x = xval;
    *y = yval;
}

/* ζȡX,Yֵ */
#define TP_ERR_RANGE    50      // Χ

/**
 * @name tp_read_xy2
 * @brief ȡ2δIC, ˲
 * @param x,y: ȡֵ
 * @return 0, ʧ; 1, ɹ;
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 *          2ζȡIC,εƫܳERR_RANGE,
 *          ,Ϊȷ,.úܴ׼ȷ.
 */
static uint8_t tp_read_xy2(uint16_t *x, uint16_t *y)
{
    uint16_t xdata x1, y1;
    uint16_t xdata x2, y2;

    tp_read_xy1(&x1, &y1);   /* ȡһ */
    tp_read_xy1(&x2, &y2);   /* ȡڶ */

    /* ǰβ+-TP_ERR_RANGE */
    if (((x2 <= x1 && x1 < x2 + TP_ERR_RANGE) || (x1 <= x2 && x2 < x1 + TP_ERR_RANGE)) &&
            ((y2 <= y1 && y1 < y2 + TP_ERR_RANGE) || (y1 <= y2 && y2 < y1 + TP_ERR_RANGE)))
    {
        *x = (x1 + x2) / 2;
        *y = (y1 + y2) / 2;
        return 1;
    }

    return 0;
}


/******************************************************************************************/
/* LCDйصĺ, У׼õ */

/**
 * @brief       һУ׼õĴ(ʮּ)
 * @param       x,y   : 
 * @param       color : ɫ
 * @retval      
 */
static void tp_draw_touch_point(uint16_t x, uint16_t y, uint16_t color)
{
    lcd_draw_line(x - 12, y, x + 13, y, color); // 
    lcd_draw_line(x, y - 12, x, y + 13, color); // 
    lcd_draw_point(x + 1, y + 1, color);
    lcd_draw_point(x - 1, y + 1, color);
    lcd_draw_point(x + 1, y - 1, color);
    lcd_draw_point(x - 1, y - 1, color);
    lcd_draw_circle(x, y, 6, 0, color);            // Ȧ
}

/**
 * @brief       һ(2*2ĵ)
 * @param       x,y   : 
 * @param       color : ɫ
 * @retval      
 */
void tp_draw_big_point(uint16_t x, uint16_t y, uint16_t color)
{
    lcd_draw_point(x, y, color);       /* ĵ */
    lcd_draw_point(x + 1, y, color);
    lcd_draw_point(x, y + 1, color);
    lcd_draw_point(x + 1, y + 1, color);
}

/******************************************************************************************/

/**
 * @brief       ɨ
 * @param       mode: ģʽ
 *   @arg       0, Ļ;
 *   @arg       1, (У׼ⳡ)
 * @retval      0, ޴; 1, д;
 */
uint8_t tp_scan(uint8_t mode)
{
    if (RT_PEN == 0)     /* а */
    {
        if (mode)       /* ȡ, ת */
        {
            tp_read_xy2(&tp_dev.x[0], &tp_dev.y[0]);
        }
        else if (tp_read_xy2(&tp_dev.x[0], &tp_dev.y[0]))     /* ȡĻ, Ҫת */
        {
            /* X ת߼(ӦLCDĻXֵ) */
            tp_dev.x[0] = (signed short)(tp_dev.x[0] - tp_dev.xc) / tp_dev.xfac + lcddev.width / 2;

            /* Y ת߼(ӦLCDĻYֵ) */
            tp_dev.y[0] = (signed short)(tp_dev.y[0] - tp_dev.yc) / tp_dev.yfac + lcddev.height / 2;
        }

        if ((tp_dev.sta & TP_PRES_DOWN) == 0)   /* ֮ǰûб */
        {
            tp_dev.sta = TP_PRES_DOWN | TP_CATH_PRES;   /*  */
            tp_dev.x[CT_MAX_TOUCH - 1] = tp_dev.x[0];   /* ¼һΰʱ */
            tp_dev.y[CT_MAX_TOUCH - 1] = tp_dev.y[0];
        }
    }
    else
    {
        if (tp_dev.sta & TP_PRES_DOWN)      /* ֮ǰǱµ */
        {
            tp_dev.sta &= ~TP_PRES_DOWN;    /* ǰɿ */
        }
        else     /* ֮ǰûб */
        {
            tp_dev.x[CT_MAX_TOUCH - 1] = 0;
            tp_dev.y[CT_MAX_TOUCH - 1] = 0;
            tp_dev.x[0] = 0xffff;
            tp_dev.y[0] = 0xffff;
        }
    }

    return tp_dev.sta & TP_PRES_DOWN; /* صǰĴ״̬ */
}

// /* TP_SAVE_ADDR_BASE崥У׼EEPROMλ(ʼַ)
//  * ռÿռ : 13ֽ.
//  */
// #define TP_SAVE_ADDR_BASE   0

/**
 * @brief       У׼
 *   @note      EEPROMоƬ(24C02),ʼַΪTP_SAVE_ADDR_BASE.
 *              ռôСΪ13ֽ
 * @param       
 * @retval      
 */
void tp_save_adjust_data(void)
{
    uint8_t *p = (uint8_t *)&tp_dev.xfac; /* ָ׵ַ */
    uint8_t temp[13] = {0};
    uint8_t i;

    /* pָtp_dev.xfacĵַ, p+4tp_dev.yfacĵַ
     * p+8tp_dev.xoffĵַ,p+10,tp_dev.yoffĵַ
     * ܹռ12ֽ(4)
     * p+12ڴűǵ败ǷУ׼(0X0A)
     * p[12]д0X0A. ѾУ׼.
     */
    // AT24Cxx_Write(TP_SAVE_ADDR_BASE, p, 12);          /* 12ֽ(xfac,yfac,xc,yc) */
    // AT24Cxx_Write_Byte(TP_SAVE_ADDR_BASE + 12, 0X0A); /* У׼ֵ */

    for ( i = 0; i < 12; i++)
    {
        temp[i] = *p;
        p++;
    }
    temp[12] = 0x0A;
    EEOPROM_Write(TP_SAVE_ADDR_BASE, temp, 13);
}

/**
 * @brief       ȡEEPROMУ׼ֵ
 * @param       
 * @retval      0ȡʧܣҪУ׼
 *              1ɹȡ
 */
uint8_t tp_get_adjust_data(void)
{
    uint8_t *p = (uint8_t *)&tp_dev.xfac;
    uint8_t temp = 0;

    /* ֱָtp_dev.xfacַб, ȡʱ,ȡ
     * дָtp_dev.xfac׵ַ, ͿԻԭдȥֵ, Ҫ
     * . ˷ڸ(ṹ)ı/ȡ(ṹ).
     */
    // AT24Cxx_Read(TP_SAVE_ADDR_BASE, p, 12);             /* ȡ12ֽ */
    // temp = AT24Cxx_Read_Byte(TP_SAVE_ADDR_BASE + 12);   /* ȡУ׼״̬ */
    EEPROM_Read(TP_SAVE_ADDR_BASE, p, 12);
    EEPROM_Read(TP_SAVE_ADDR_BASE + 12, &temp, 1);

    if (temp == 0X0A)
    {
        return 1;
    }

    return 0;
}

/* ʾַ */
char *const TP_REMIND_MSG_TBL = "Please use the stylus click the cross on the screen.The cross will always move until the screen adjustment is completed.";

/**
 * @brief       ʾУ׼()
 * @param       xy[5][2]: 5ֵ
 * @param       px,py   : x,yı(Լӽ1Խ)
 * @retval      
 */
static void tp_adjust_info_show(uint16_t xy[5][2], double px, double py)
{
    uint8_t xdata i;
    char xdata sbuf[20];

    for (i = 0; i < 5; i++)   /* ʾ5ֵ */
    {
        lcd_printf(40, 160 + (i * 20), 0, ascii_1608[0], Fsize1608, RED, BLACK, "x%d:%d", i + 1, xy[i][0]);
        sprintf(sbuf, "y%d:%d", i + 1, xy[i][1]);
        lcd_printf(40, 160 + (i * 20), 0, ascii_1608[0], Fsize1608, RED, BLACK, "y%d:%d", i + 1, xy[i][1]);
    }

    /* ʾX/Yı */
    lcd_fill_area(40, 160 + (i * 20), lcddev.width - 1, 16, BLACK);  /* ֮ǰpx,pyʾ */
    lcd_printf(40, 160 + (i * 20), 0, ascii_1608[0], Fsize1608, RED, BLACK, "px:%0.2f%d", px, 0);
    lcd_printf(40 + 80, 160 + (i * 20), 0, ascii_1608[0], Fsize1608, RED, BLACK, "py:%0.2f%d", py, 0);
}

/**
 * @brief       У׼
 *   @note      ʹУ׼(ԭٶ)
 *              õx/yxfac/yfacֵ(xc,yc)4
 *              ǹ涨: 꼴ADɼֵ,Χ0~4095.
 *                        ߼꼴LCDĻ, ΧΪLCDĻķֱ.
 *
 * @param       
 * @retval      
 */
void tp_adjust(void)
{
    uint16_t xdata pxy[5][2];     /* 껺ֵ */
    uint8_t  xdata cnt = 0;
    short s1, s2, s3, s4;   /* 4ֵ */
    double px, py;          /* X,Y,жǷУ׼ɹ */
    uint16_t xdata outtime = 0;
    cnt = 0;

    lcd_clear(BLACK);       /*  */
    /* ʾʾϢ */
    lcd_printf(40, 40, 0, ascii_1608[0], Fsize1608, RED, BLACK, TP_REMIND_MSG_TBL);
    tp_draw_touch_point(20, 20, RED);   /* 1 */
    tp_dev.sta = 0;         /* ź */

    while (1)               /* 10ûа,Զ˳ */
    {
        tp_dev.scan(1);     /* ɨ */

        if ((tp_dev.sta & 0xc000) == TP_CATH_PRES)   /* һ(ʱɿ.) */
        {
            outtime = 0;
            tp_dev.sta &= ~TP_CATH_PRES;    /* ǰѾ. */

            pxy[cnt][0] = tp_dev.x[0];      /* X */
            pxy[cnt][1] = tp_dev.y[0];      /* Y */
            cnt++;

            switch (cnt)
            {
                case 1:
                    tp_draw_touch_point(20, 20, BLACK);                 /* 1 */
                    tp_draw_touch_point(lcddev.width - 20, 20, RED);    /* 2 */
                    break;

                case 2:
                    tp_draw_touch_point(lcddev.width - 20, 20, BLACK);  /* 2 */
                    tp_draw_touch_point(20, lcddev.height - 20, RED);   /* 3 */
                    break;

                case 3:
                    tp_draw_touch_point(20, lcddev.height - 20, BLACK); /* 3 */
                    tp_draw_touch_point(lcddev.width - 20, lcddev.height - 20, RED);    /* 4 */
                    break;

                case 4:
                    lcd_clear(BLACK);   /* , ֱ */
                    tp_draw_touch_point(lcddev.width / 2, lcddev.height / 2, RED);  /* 5 */
                    break;

                case 5:     /* ȫ5Ѿõ */
                    s1 = pxy[1][0] - pxy[0][0]; /* 2͵1Xֵ(ADֵ) */
                    s3 = pxy[3][0] - pxy[2][0]; /* 4͵3Xֵ(ADֵ) */
                    s2 = pxy[3][1] - pxy[1][1]; /* 4͵2Yֵ(ADֵ) */
                    s4 = pxy[2][1] - pxy[0][1]; /* 3͵1Yֵ(ADֵ) */

                    px = (double)s1 / s3;       /* X */
                    py = (double)s2 / s4;       /* Y */

                    if (px < 0)px = -px;        /*  */
                    if (py < 0)py = -py;        /*  */

                    if  (px < 0.95 || px > 1.05 || py < 0.95 || py > 1.05 ||     /* ϸ */
                            abs(s1) > 4095 || abs(s2) > 4095 || abs(s3) > 4095 || abs(s4) > 4095 || /* ֵϸ, 귶Χ */
                            abs(s1) == 0 || abs(s2) == 0 || abs(s3) == 0 || abs(s4) == 0            /* ֵϸ, 0 */
                        )
                    {
                        cnt = 0;
                        tp_draw_touch_point(lcddev.width / 2, lcddev.height / 2, BLACK); /* 5 */
                        tp_draw_touch_point(20, 20, RED);   /* »1 */
                        tp_adjust_info_show(pxy, px, py);   /* ʾǰϢ, */
                        continue;
                    }

                    tp_dev.xfac = (float)(s1 + s3) / (2 * (lcddev.width - 40));
                    tp_dev.yfac = (float)(s2 + s4) / (2 * (lcddev.height - 40));

                    tp_dev.xc = pxy[4][0];      /* X, */
                    tp_dev.yc = pxy[4][1];      /* Y, */

                    lcd_clear(BLACK);   /*  */
                    // lcd_show_string(35, 110, lcddev.width, lcddev.height, 16, "Touch Screen Adjust OK!", BLUE); /* У */
                    lcd_printf(35, 100, 0, ascii_1608[0], Fsize1608, BLUE, BLACK, "Touch Screen Adjust OK!");
                    delay_ms(1000);
                    tp_save_adjust_data();

                    lcd_clear(BLACK);/*  */
                    return;/* У */
            }
        }

        delay_ms(10);
        outtime++;

        if (outtime > 1000)
        {
            tp_get_adjust_data();
            break;
        }
    }
}

void TP_Set_GPIO(void)
{
    // P11(RT_CS)P12(RT_PEN)Ϊ׼˫ڣ
    P1M0 &= ~0x06; P1M1 &= ~0x06;
    P1PU |= 0x06; 

    RT_CS = 1;
    RT_PEN = 1;
}

/**
 * @brief       ʼ
 * @param       
 * @retval      0,ûнУ׼
 *              1,йУ׼
 */
uint8_t TP_Init(void)
{
    TP_Set_GPIO();
	SPI_Init();

    tp_dev.touchtype = 0;                   /* Ĭ( & ) */
    tp_dev.touchtype |= lcddev.dir & 0X01;  /* LCDжǺ */

    tp_read_xy1(&tp_dev.x[0], &tp_dev.y[0]); /* һζȡʼ */
    // AT24Cxx_Init();                         /* ʼ24CXX */

    if (tp_get_adjust_data())
    {
        return 0;           /* ѾУ׼ */
    }
    else                    /* δУ׼? */
    {
        lcd_clear(BLACK);   /*  */
        tp_adjust();        /* ĻУ׼ */
        tp_save_adjust_data();
    }

    tp_get_adjust_data();

    return 1;
}


