#include "./Middlewares/SCREEN/screen.h"
#include "./BSP/TIM/tim.h"

//------------------------------------------------------------

u8 xdata state = 1;

//------------------------------------------------------------

/**
 * @name screen_clear
 * @brief 
 * @param color ɫ
 * @version 汾v1.0
 * @date ڣ2024-12-10
 * @author ߣϫ
 * @note עͣ
 */
void screen_clear(uint16_t color)
{
    lcd_draw_rectangle(24 * 1, 24 * 0 + 16, 24 * 9, 24 * 4 + 16, 1, color); // ɫ
}

void screen_show_char(uint8_t x, uint8_t y, uint16_t fc, uint16_t bc, char chr)
{
    uint8_t px, py;
    px = 24 + x;
    py = 16 + 12 * y;
    
    lcd_show_char(px, py, 0, ascii_2412, Fsize2412, fc, bc, chr);
}

void screen_show_CN(uint8_t x, uint8_t y, uint16_t fc, uint16_t bc, char* GBK)
{
    uint8_t px, py;
    px = 24 + x;
    py = 16 + 12 * y;

    lcd_show_chinese_24x24(px, py, 0, Font_GB24, fc, bc, GBK);
}

void screen_show_EN_CN(uint8_t x, uint8_t y, uint16_t fc, uint16_t bc, char *str)
{
    uint8_t xdata pGBK = 0;
    uint8_t xdata i, k = 0;
    uint8_t xdata SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
    uint8_t xdata sizex = Fsize2412 / 2;
    uint8_t xdata sizey = Fsize2412;
    uint8_t xdata px = x;
    uint8_t xdata py = y;
    
    for (i = 0; str[i] != '\0'; i++)
    {
        if ( (str[i] <= '~') && (str[i] >= ' ') )
        {
            screen_show_char(px, py, fc, bc, str[i]);
            px += sizex;
            // Զ
            if (px + sizex > 192)
            {
                px = 0;
                py += 2;
            }
        }
        else
        {
            SingleChinese[pGBK] = str[i];           // ȡִݵ
            pGBK++;                                 // ƴ

            // ȡﺺֳʱȡһĺ
            if (pGBK >= TFT_CHN_CHAR_WIDTH)
            {
                pGBK = 0;       // ƴι
                screen_show_CN(px, py, fc, bc, SingleChinese);
                // Զ
                px += sizey;
                if (px + sizey > 192)
                {
                    px = 0;
                    py += 2;
                }
            }
        }
    }
}

/**
 * @name screen_printf
 * @brief Ļӡ
 * @param x     0-192(24*0-7)
 * @param y     0-7(24*4=96)
 * @param fc    ɫ
 * @param bc    ɫ
 * @param format İ
 * @version 汾v1.0
 * @date ڣ2024-12-10
 * @author ߣϫ
 * @note עͣ
 */
void screen_printf(uint8_t x, uint8_t y, uint16_t fc, uint16_t bc, char *format, ...)
{
    char xdata String[64];               // ַ
    va_list arg;                   // ɱб͵ıarg
    va_start(arg, format);         // formatʼղбarg
    vsprintf(String, format, arg); // ʹvsprintfӡʽַͲбַ
    va_end(arg);                   // arg
    
    // lcd_show_cn_en(24 + x, 16 + 12 * y, 0, ascii_2412, Fsize2412, fc, bc, String);
    screen_show_EN_CN(x, y, fc, bc, String);
}

/**
 * @name screen_draw_point
 * @brief Ļ
 * @param x     0-192(24*8=192)
 * @param y     0-96(24*4=96)
 * @param color ɫ
 * @version 汾v1.0
 * @date ڣ2024-12-10
 * @author ߣϫ
 * @note עͣ
 */
void screen_draw_point(uint8_t x, uint8_t y, uint16_t color)
{
    if (x > 192 || y > 96)
        return;

    lcd_draw_point(24 + x, 16 + y, color);
}


void screen_draw_line(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1, uint16_t color)
{
    if (x0 > 192 || y0 > 96)
        return;
    if (x1 > 192 || y1 > 96)
        return;

    lcd_draw_line(24 + x0, 16 + y0, 24 + x1, 16 + y1, color);
}


void Cursor_Blink(u16 x, u8 y, u8 count)
{
    static u32 xdata count_now = 0; // һʱ
    static bit xdata BlinkFlag = 0;
    uint16_t xdata px = x;
    uint8_t xdata py = y;

    if (px > 192)
    {
        px -= 193;
        py += 2;
    }

    if (Sys_Time_10ms >= (count_now + count))
    {
        count_now = Sys_Time_10ms;
        if (BlinkFlag == 0)
        {

            lcd_draw_line(24 + px, 16 + 12 * py, 24 + px, 16 + 12 * py + 24, screen_fc);
        }
        else
        {

            lcd_draw_line(24 + px, 16 + 12 * py, 24 + px, 16 + 12 * py + 24, screen_bc);
        }
        BlinkFlag = !BlinkFlag;

    }
}

