#include "calculus.h"
#include "fun.h"
#include "menu.h"
#include "./Middlewares/TFT_KEYBOARD/tft_keyboard.h"

//------------------------------------------------------------

uchar hanshu_buff[26] = "x^2"; // 溯ʽ
double hanshu_a = 1;
double hanshu_b = 2;
double hanshu_h = 0.2;
double hanshu_y = 2;

//------------------------------------------------------------

void calculus_funcWR(u8 keynum)
{
#define IBlength 26
    static u8 addr = 0;
    u8 result;
    static u8 shift_flag;
    static char input_buf[IBlength] = {"    "}; // 뻺

    switch (state)
    {
    case 0: // ʼ
        screen_clear(screen_clr);
        screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "ұߵĺ\xfd");
        screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "%s", input_buf);
        memset(input_buf, '\0', IBlength);
        addr = 0;
        state++;
        break;

    case 1: // ȴ
        Cursor_Blink((u8)(addr * 12), 4, 50);
        if (keynum > 0)
        {
            if (keynum == 8) // 
            {
                if (addr >= 1)
                    addr -= 1;
            }
            else if (keynum == 10) // 
            {
                if (input_buf[addr] != 0)
                    addr += 1;
            }
            else if (keynum == 21) // 
            {
                screen_clear(screen_clr); // ڻһλĺ
                String_Delete(&input_buf, IBlength, addr);
                if (addr > 0)
                    addr--;
            }
            else if (keynum == 22) // 
            {
                memset(input_buf, '\0', IBlength);
                screen_clear(screen_clr);
                addr = 0;
            }
            else if (keynum == 17)
            {
                screen_clear(screen_clr);
                screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "1.sinh");
                screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "2.cosh");
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, "3.tanh");
                state = 5;
            }
            else if (keynum == '=') // 
            {
                addr = String_length(input_buf);
                input_buf[addr] = '\0';
                P_Index.Menu_KeyFunc = 0;
                screen_clear(screen_clr);
                strcpy(hanshu_buff, input_buf);
            }
            else if (keynum == 1) // 
            {
                shift_flag = !shift_flag;
            }
            else
            {
                if (shift_flag)
                {
                    keynum += 0x80;
                    shift_flag = 0;
                }
                result = String_Insert(&input_buf, IBlength, addr, keynum);
                if (result != 0xff)
                {
                    addr += result;
                }
            }
            if (state == 1)
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, &input_buf);
            keynum = 0;
        }

        break;

    case 5: // ⹦ݔ
        if (keynum > 0)
        {
            if ((keynum == '1') || (keynum == '2') || (keynum == '3'))
            {
                addr += String_Insert(&input_buf, IBlength, addr, 120 + keynum - '1');
                state = 1;
                screen_clear(screen_clr);
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, &input_buf);
            }
        }
        break;
    }
}

void calculus_funcWRa(u8 keynum)
{
#define IBlength 26
    static u8 addr = 0;
    static char input_buf[IBlength] = {"    "}; // 뻺

    switch (state)
    {
    case 0: // ʼ
        screen_clear(screen_clr);
        screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "a =");
        screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "%g", hanshu_a);
        memset(input_buf, '\0', IBlength);
        addr = 0;
        state++;
        break;

    case 1: // ȴ
        Cursor_Blink((u8)(addr * 12), 4, 50);
        if (keynum > 0)
        {
            if (keynum == 8) // 
            {
                if (addr >= 1)
                    addr -= 1;
            }
            else if (keynum == 10) // 
            {
                if (input_buf[addr] != 0)
                    addr += 1;
            }
            else if (((keynum >= '0') && (keynum <= '9')) || (keynum == '.') || (keynum == '-'))
            {
                input_buf[addr] = keynum;
                addr++;
            }
            else if (keynum == 21)
            {
                addr--;
                input_buf[addr] = ' ';
            }
            else if (keynum == '=')
            {
                hanshu_a = atof(input_buf);
                P_Index.Menu_KeyFunc = 0;
            }
            if (state == 1)
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, &input_buf);
            keynum = 0;
        }

        break;
    }
}

void calculus_funcWRb(u8 keynum)
{
#define IBlength 26
    static u8 addr = 0;
    static char input_buf[IBlength] = {"    "}; // 뻺

    switch (state)
    {
    case 0: // ʼ
        screen_clear(screen_clr);
        screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "b =");
        screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "%g", hanshu_b);
        memset(input_buf, '\0', IBlength);
        addr = 0;
        state++;
        break;

    case 1: // ȴ
        Cursor_Blink((u8)(addr * 8), 4, 50);
        if (keynum > 0)
        {
            if (keynum == 8) // 
            {
                if (addr >= 1)
                    addr -= 1;
            }
            else if (keynum == 10) // 
            {
                if (input_buf[addr] != 0)
                    addr += 1;
            }
            else if (((keynum >= '0') && (keynum <= '9')) || (keynum == '.') || (keynum == '-'))
            {
                input_buf[addr] = keynum;
                addr++;
            }
            else if (keynum == 21)
            {
                addr--;
                input_buf[addr] = ' ';
            }
            else if (keynum == '=')
            {
                hanshu_b = atof(input_buf);
                P_Index.Menu_KeyFunc = 0;
            }
            if (state == 1)
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, &input_buf);
            keynum = 0;
        }

        break;
    }
}
void calculus_funcWRh(u8 keynum)
{
#define IBlength 26
    static u8 addr = 0;
    static char input_buf[IBlength] = {"    "}; // 뻺

    switch (state)
    {
    case 0: // ʼ
        screen_clear(screen_clr);
        screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "h =");
        screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "%g", hanshu_h);
        memset(input_buf, '\0', IBlength);
        addr = 0;
        state++;
        break;

    case 1: // ȴ
        Cursor_Blink((u8)(addr * 12), 4, 50);
        if (keynum > 0)
        {
            if (keynum == 8) // 
            {
                if (addr >= 1)
                    addr -= 1;
            }
            else if (keynum == 10) // 
            {
                if (input_buf[addr] != 0)
                    addr += 1;
            }
            else if (((keynum >= '0') && (keynum <= '9')) || (keynum == '.') || (keynum == '-'))
            {
                input_buf[addr] = keynum;
                addr++;
            }
            else if (keynum == 21)
            {
                addr--;
                input_buf[addr] = ' ';
            }
            else if (keynum == '=')
            {
                hanshu_h = atof(input_buf);
                P_Index.Menu_KeyFunc = 0;
            }
            if (state == 1)
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, &input_buf);
            keynum = 0;
        }

        break;
    }
}

void calculus_funcWRy(u8 keynum)
{
#define IBlength 26
    static u8 addr = 0;
    static char input_buf[IBlength] = {"    "}; // 뻺

    switch (state)
    {
    case 0: // ʼ
        screen_clear(screen_clr);
        screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "Ҷ˵yֵ=");
        screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "%g", hanshu_y);
        memset(input_buf, '\0', IBlength);
        addr = 0;
        state++;
        break;

    case 1: // ȴ
        Cursor_Blink((u8)(addr * 12), 4, 50);
        if (keynum > 0)
        {
            if (keynum == 8) // 
            {
                if (addr >= 1)
                    addr -= 1;
            }
            else if (keynum == 10) // 
            {
                if (input_buf[addr] != 0)
                    addr += 1;
            }
            else if (((keynum >= '0') && (keynum <= '9')) || (keynum == '.') || (keynum == '-'))
            {
                input_buf[addr] = keynum;
                addr++;
            }
            else if (keynum == 21)
            {
                addr--;
                input_buf[addr] = ' ';
            }
            else if (keynum == '=')
            {
                hanshu_y = atof(input_buf);
                P_Index.Menu_KeyFunc = 0;
            }
            if (state == 1)
                screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, &input_buf);
            keynum = 0;
        }

        break;
    }
}

void calculus_funcShow(u8 keynum)
{
    static int n = 0;
    u8 i = 0;
    char dat[16];
    static u8 addr_str = 0;
    double x_array[10]; // ΢̵ַĽб
    double y_array[10];
    double temp_0 = 0; // ʱֵ
    double temp_1 = 0;

    switch (state)
    {
    case 0: // ʼ
        screen_clear(screen_clr);
        addr_str = 0;
        n = (int)(hanshu_b - hanshu_a) / hanshu_h;

        if (hanshu_a > hanshu_b)
            // Screen_ShowStr(0, (u8)(0), "a>b,wrong");
            screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "a>b,wrong");
        else if (hanshu_h < 0)
            // Screen_ShowStr(0, (u8)(0), "h<0,wrong");
            screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "h<0,wrong");
        else if (n < 0)
        {
            screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "볢С(b-a)");
            screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "h");
        }
        else
        {
            x_array[0] = hanshu_a;
            y_array[0] = hanshu_y;
            for (i = 0; i < n + 1; i++)
            {

                x_array[i + 1] = x_array[i] + hanshu_h;
                x = x_array[i];
                y = y_array[i];
                alg_calc_expression(hanshu_buff, &temp_0, 0);
                y_array[i + 1] = y_array[i] + hanshu_h * temp_0;
                x = x_array[i + 1];
                y = y_array[i + 1];
                alg_calc_expression(hanshu_buff, &temp_1, 0);
                y_array[i + 1] = y_array[i] + hanshu_h / 2 * (temp_0 + temp_1);
            }
            i = 0;
        }
        state++;
        keynum = 4;

    case 1: // ȴ
        if (keynum > 0)
        {
            if ((keynum == 4) && (addr_str > 0))
            {
                addr_str--;
            }
            else if ((keynum == 9) && (addr_str < n))
            {
                addr_str++;
            }
            screen_clear(screen_clr);
            sprintf(dat, "x[%d]=", addr_str);
            screen_printf(0 * 1.5, (u8)(0), screen_fc, screen_bc, "%s", dat);
            screen_printf(0 * 1.5, (u8)(2), screen_fc, screen_bc, "%g", x_array[addr_str]);
            sprintf(dat, "y[%d]=", addr_str);
            screen_printf(0 * 1.5, (u8)(4), screen_fc, screen_bc, "%s", dat);
            screen_printf(0 * 1.5, (u8)(6), screen_fc, screen_bc, "%g", y_array[addr_str]);
            keynum = 0;
        }

        break;
    }
}
